{this unit accepts two vectors x and y representing points in 2d space.
 it outputs a grid [0..100,0..100] containing approximate density values
 achieved through the adaptive kernel method.  The kernel used is the
 Epichnakov spp?.}

UNIT AKLib;

INTERFACE

USES GlobType,QSort2,Linlib,Utility;

PROCEDURE DoAk(n : Word;VAR X,Y : AKArr;VAR Grid : AKMatrix);

IMPLEMENTATION

VAR
    m,Holder,J1,J2                                  : Word;
    Xmin,Xmax,Xmean,Xstdev,Ymin,Ymax,Ymean,Ystdev,r,
    Twovpi,Axx,Wwsq2,c,Rr,Hsq,Nhsqr,DivHsq,Xx,Yy    : Single;
    YArr2                                           : RowArr;

(*
PROCEDURE Stats(n : Word;VAR x,y : AKArr);
     VAR
        i             : Word;
        Xi,Yi,Range   : Single;
     BEGIN
        m := n;
	Xmin:=x[1];
	Xmax:=Xmin;
	Ymin:=y[1];
	Ymax:=Ymin;
	Xmean:=0;
	Ymean:=0;
	Xstdev:=0;
	Ystdev:=0;
	r:=0;
        FOR i := 2 TO n DO BEGIN
	   Xi:=x[i];
	   Yi:=y[i];
	   IF (Xmin > Xi) THEN Xmin:=Xi;
	   IF (Ymin > Yi) THEN Ymin:=Yi;
	   IF (Xmax < Xi) THEN Xmax:=Xi;
	   IF (Ymax < Yi) THEN Ymax:=Yi;
        END;
	IF ((Xmax-Xmin) > (Ymax-Ymin)) THEN
	   Range:=Xmax-Xmin
	ELSE
	   Range:=Ymax-Ymin;
	FOR i:= 1 TO n DO BEGIN
	   Xi:=(x[i] - Xmin)/Range;
	   Yi:=(y[i] - Ymin)/Range;
	   Xmean:=Xmean + Xi;
	   Ymean:=Ymean + Yi;
	   Xstdev:=Xstdev + Sqr(Xi);
	   Ystdev:=Ystdev + Sqr(Yi);
	   r:=r + Xi*Yi;
        END;
	Xmean:=Xmean/n;
	Ymean:=Ymean/n;
	Xstdev:=Sqrt(Xstdev/n - Sqr(Xmean));
	Ystdev:=Sqrt(Ystdev/n - Sqr(Ymean));
	r:=(r/n - Xmean*Ymean)/(Xstdev*Ystdev);
	Xmean:=Range*Xmean + Xmin;
	Ymean:=Range*Ymean + Ymin;
	Xstdev:=Xstdev*Range;
	Ystdev:=Ystdev*Range;
END;
*)
PROCEDURE Stats(n : Word;VAR x,y : AKArr);
     BEGIN
        m := n;
	Xmin:=Min(n,x);
	Xmax:=Max(n,x);
	Ymin:=Min(n,y);
	Ymax:=Max(n,y);
	Xmean:=Mean(n,x);
	Ymean:= Mean(n,y);
	Xstdev:=Std(n,XMean,x);
        Ystdev := Std(n,YMean,y);
END;
FUNCTION XToThe1V6(m : Word):Extended;
         BEGIN
              XToThe1V6 := Exp(Ln(m) * 1/6);
END;
PROCEDURE Initialbw(VAR h : Single);
     BEGIN
	h:=1.77*Sqrt((Sqr(Xstdev)+Sqr(Ystdev))/2)/XtoThe1V6(m)
END;

{FxedJLoop performs the following loop in external assembly language}

FUNCTION FxedJLoop(n,i : Word; VAR x,y : AKArr):Single; EXTERNAL;
{$L Akf4}

(*
    var
       j    : Word;
       a,ff : Single;
    Label
         Loop1,Loop2;
begin
   FOR j:= Succ(i) TO n DO BEGIN   {work up from xi}
            a := Sqr(x[j]-Xx);           {is it in the circle based on X?}
            IF a < Hsq THEN BEGIN        {if not then get out}
               a := a + Sqr(y[j]-Yy);    {if so, then compute a}
               IF (a < Hsq) THEN         {is it still in the circle?}
                  Ff := Ff + Twovpi - (a*DivHsq)  {if so update ff}
            END
            ELSE
                GOTO Loop1
        END;
        Loop1:
        FOR j := Pred(i) DOWNTO 1 DO BEGIN        {down loop}
            a := Sqr(x[j]-Xx);                    {ditto...}
            IF a < Hsq THEN BEGIN
               a := a + Sqr(y[j]-Yy);
               IF (a < Hsq) THEN
                  Ff := Ff + Twovpi - (a*DivHsq)
            END
            ELSE
                GOTO Loop2;
        END;
        Loop2:
        FxedJLoop := Ff;
end;
*)

PROCEDURE FxdWid(n : Word;VAR x,y,f : AKArr;h : Single);
   VAR
      i                    : Word;
   BEGIN
      Hsq := Sqr(h);
      Nhsqr := 1/(Hsq*n);
      DivHsq := (1/Hsq)*Twovpi;
      FOR i:=1 TO n DO BEGIN
         Xx := x[i];
         Yy := y[i];
         f[i] := FxedJLoop(n,i,x,y)*Nhsqr;
      END;
END;
PROCEDURE AdptBW(n : Word;VAR f,Bw : AKArr);
   VAR
      i     : Word;
   BEGIN
      Gmean := 0.0;
      FOR i:=1 TO n DO
         Gmean := Gmean + Ln(f[i]);
     Gmean := Exp(Gmean/n);
      FOR i:=1 TO n DO
         Bw[i] := Sqrt(Gmean/f[i])
END;

FUNCTION Max2(a,b : Single):Single;
         BEGIN
              IF a > b THEN
                 Max2 := a
              ELSE Max2 := b;
END;

PROCEDURE SetGPm(VAR n,Nx,Ny : Word;VAR X0,Y0,Cell : Single);

      VAR
         Range,Buff : Single;
      BEGIN
      Nx := 100;
      Ny := Nx;
      IF n < 50 THEN
         Buff := 1.8
      ELSE IF n < 200 THEN
          Buff := 1.5
      ELSE
          Buff := 1.2;
      Range := Buff*Max2(Xmax-Xmin,Ymax-Ymin);
      Cell := Range/Nx;
      X0 := (Xmin+Xmax)/2 - Range/2;
      Y0 := (Ymin+Ymax)/2 - Range/2;
END;

{Note JLoop is an external near procedure}

PROCEDURE JLoop(VAR Row : RowArr);EXTERNAL;
{$L jloop3}

{          VAR
             j  : Word;
          begin
               for j:=j1 to j2 do begin
                   rr := (ax + YArr2[j]) * wwSq2;
                   if (rr < c) then
                     Row[j] := Row[j] + (c - rr);
               end;
end;
}

{Procedure YJLoop squares J1..J2 elements in array YArr and deposits them in
 YArr2}

PROCEDURE YJLoop(n : Word; VAR a,b);
EXTERNAL;
{$L yjoop}

         {var j : Word;
          begin
               for j := j1 to j2 do
                   Yarr2[j] := Sqr(YArr[j] - yy);
end;}

PROCEDURE AKGrid(    n                          : Word;
                  VAR x,y,Bw                     : AKArr;
                      h                          : Single;
                  VAR Grid                       : AkMatrix);
  VAR
     I1,I2,
     i,j,k                                        : Word;
     Xx,Ww,WwSq                                   : Single;
     YArr,XArr                                    : RowArr;
  BEGIN
      SetGPm(n,Nx,Ny,X0,Y0,Cell);
      ZeroFill(Grid,SizeOf(AkMatrix));
      FOR i := 0 TO Nx DO
          XArr[i] := X0 + Cell*i;
      FOR j := 0 TO Ny DO
          YArr[j] := Y0 + Cell*j;
      FOR k:=1 TO n DO BEGIN
         Xx := x[k];
         Yy := y[k];
         Ww := Bw[k]*h;
         WwSq := Sqr(Ww);
         c := (1/(n*WwSq)) * TwoVpi;
         WwSq2 := (1/WwSq) * c;
         I1 := IntMax(0, Trunc((Xx-X0-Ww)/Cell));
         I2 := IntMin(Nx,Trunc((Xx-X0+Ww)/Cell));
         J1 := IntMax(0, Trunc((Yy-Y0-Ww)/Cell));
         J2 := IntMin(Ny,Trunc((Yy-Y0+Ww)/Cell));
         YJLoop(Succ(J2)-J1,YArr[J1],YArr2[J1]);
         FOR i:=I1 TO I2 DO BEGIN
            Axx := Sqr(XArr[i] - Xx);
            IF Axx < WwSq THEN BEGIN
               JLoop(Grid[i]);
            END;
         END;
      END;
END;
PROCEDURE DoAk(n : Word;VAR X,Y : AKArr;VAR Grid : AkMatrix);
          VAR
             Bw,f : AKArr;
             h    : Single;
          BEGIN
               QckSrt2(n,x,y);
               Stats(n,x,y);
               InitialBw(h);
               FxdWid(n,x,y,f,h);
               AdptBw(n,f,Bw);
               AKGrid(n,x,y,Bw,h,Grid);
END;
BEGIN
     TwoVpi := 2/Pi;
END.