UNIT ContLib;

INTERFACE

USES Utility,GlobType,Linlib,Qsort2;

PROCEDURE InitContour(    n          : Word;
                      VAR X,Y        : AkArr;
                      VAR G          : AKMatrix);
PROCEDURE DisposeContour;
PROCEDURE MakeAContour(    n                 : Word;
                           ContVal           : Single;
                       VAR Poly              : PolyType;
                       VAR g                 : AKMatrix);

IMPLEMENTATION

CONST
     MaxN = 2300;
     NE = 1;NW = 2;SE = 3;SW = 4;
     Top = 5;Right = 6;Left = 7;Bottom = 8;
     SpaceUsed : Boolean = FALSE;
     Xx : Array[1..20] OF Single =
                   (0,0,0,0,0,0,0,0,0,0,1, 1,-1,0,-1, 0,-0.5,-0.5,-0.5,-0.5);
     Yy : Array[1..20] OF Single =
                   (0,0,0,0,0,0,0,0,0,-1,0,-1, 0,0,-1,-1,-0.5,-0.5,-0.5,-0.5);
TYPE
    Contours     = Array[1..10] OF Single;
    TwoArr       = Array[1..2,1..2] OF Single;
    IntArr       = Array[1..MaxN] OF Integer;
    ShortArr     = Array[1..MaxN] OF ShortInt;
    BoolArr      = Array[1..MaxN] OF Boolean;
    IndxArr      = Array[1..1000] OF Word;



VAR
   Gg                 : Array[0..5] OF Single;
   p                  : Array[1..5] OF Boolean;
   l                  : Array[1..8] OF Boolean;
   X1,Y1,X2,Y2,f      : AKArrPtr;
   GlobI,GlobJ,
   GxMin,GxMax,GyMin,
   GyMax,NSeg,NSegs   : Word;
   MinGraphX,
   MinGraphY,
   DiffGraph          : Single;
   Pp                 : Pointer;
   W                  : Word ABSOLUTE Pp;

PROCEDURE ChkNdx(VAR Ndx : Integer;Maxndx : Word);
      BEGIN
          IF (Ndx < 1) THEN
             Ndx := 1
          ELSE IF (Ndx > Maxndx) THEN
             Ndx := Maxndx
END;
FUNCTION TriInt(Xx,Yy,Z1,Z3 : Single): Single;
      BEGIN
          TriInt := Z1 + Xx*(Z3-Z1) + Yy*(2*Gmean-Z1-Z3);
END;
PROCEDURE SetCtr(n : Word;VAR x,y,f : AKArr;VAR Grid : AKMatrix);
   VAR
      i,Ix,Iy : Integer;
      Rx,Ry   : Single;
   BEGIN
      FOR i := 1 TO n DO BEGIN
         Ix := 1 + Trunc((x[i]-X0)/Cell);
         Iy := 1 + Trunc((y[i]-Y0)/Cell);
         ChkNdx(Ix,Nx);
         ChkNdx(Iy,Ny);
         Rx := (x[i] - (X0+(Ix-1)*Cell))/Cell;
         Ry := (y[i] - (Y0+(Iy-1)*Cell))/Cell;
         Gmean := (Grid[Ix,Iy]+Grid[Ix-1,Iy]+Grid[Ix,Iy-1]+Grid[Ix-1,Iy-1])/4;
         IF (Rx < Ry) THEN BEGIN
            IF (1-Rx < Ry) THEN
               f[i] := TriInt(1-Rx,1-Ry,Grid[Ix,Iy],Grid[Ix-1,Iy])
            ELSE
               f[i] := TriInt(1-Ry,Rx,Grid[Ix-1,Iy],Grid[Ix-1,Iy-1])
         END
         ELSE BEGIN
         IF (1-Rx < Ry) THEN
               f[i] := TriInt(Ry,1-Rx,Grid[Ix,Iy-1],Grid[Ix,Iy])
            ELSE
               f[i] := TriInt(Rx,Ry,Grid[Ix-1,Iy-1],Grid[Ix,Iy-1])
         END;
      END;
END;

FUNCTION CtrVal(n : Word;p : Single;VAR f: AkArr): Single;
      VAR
         Np : Word;
      BEGIN
           Np := Trunc(n*p);
           IF (Np <> n*p) THEN
              Inc(Np);
           CtrVal := f[Np];
END;
PROCEDURE Interp;
      TYPE
          ConstArr1 = Array[1..4] OF Single;
          ConstArr2 = Array[5..8] OF Single;
      CONST
           Carrx1 : ConstArr2 = (  0,   0, -1, -1);
           Carry1 : ConstArr2= (  0,   0, -1, -1);
           Carrx2 : ConstArr2 = ( -1,   0,  0,  1);
           Carry2 : ConstArr2 = (  0,  -1,  1,  0);
           Carrx3 : ConstArr1 = (  0,  -1,  0, -1);
           Carry3 : ConstArr1 = (  0,   0, -1, -1);
           Carrx4 : ConstArr1 = (-0.5, 0.5,-0.5, 0.5);
           Carry4 : ConstArr1 = (-0.5,-0.5, 0.5, 0.5);
      VAR
         GgLT, GgGT, GLT, GGT : Boolean;
         i,j,k                : Word;
         c,Ggk,Ggi            : Single;
      BEGIN
         j := 4;
         FOR k:=1 TO 2 DO BEGIN
             IF k = 1 THEN
                Ggk := Gg[1]
             ELSE
                 Ggk := Gg[4];
             GgLT := Ggk < Gg[0];
             GgGT := Ggk > Gg[0];
             FOR i := 2 TO 3 DO BEGIN
                Ggi := Gg[i];
                Inc(j);
                IF ((GgLT AND (Gg[0] < Ggi))
                   OR (GgGT AND (Gg[0] > Ggi))) THEN BEGIN
                   l[j] := TRUE;
                   c := (Gg[0]-Ggk)/(Ggi-Ggk);
                   Xx[j] := Carrx1[j] + Carrx2[j]*c;
                   Yy[j] := Carry1[j] + Carry2[j]*c;
                END
                ELSE
                   l[j] := FALSE;
             END;
         END;
         GLT := Gg[0] < Gg[5];
         GGT := Gg[0] > Gg[5];
         FOR j:=1 TO 4 DO BEGIN
             IF (((Gg[j] < Gg[0]) AND GLT)
                OR ((Gg[j] > Gg[0]) AND GGT)) THEN BEGIN
                l[j] := TRUE;
                c := (Gg[0]-Gg[j])/(Gg[5]-Gg[j]);
                Xx[j] := Carrx3[j] + Carrx4[j]*c;
                Yy[j] := Carry3[j] + Carry4[j]*c;
             END
             ELSE
                 l[j] := FALSE;
         END;
END;
PROCEDURE AddSeg(Gleft,Gright,SegA,SegB : Integer);
          BEGIN
             Inc(Nsegs);
          IF (Nsegs > 4) THEN BEGIN
                WriteLn('Too many contour segments');
                Halt;
          END;
          Inc(NSeg);
          IF (Nseg > MaxN) THEN BEGIN
                WriteLn('Too many segments');
                Halt;
          END;
          IF ((Gg[Gleft] >= Gg[0]) AND (Gg[0] >= Gg[Gright])) THEN BEGIN
             X1^[Nseg] := X0 + Cell*(GlobI+Xx[SegA]);
             Y1^[Nseg] := Y0 + Cell*(GlobJ+Yy[SegA]);
             X2^[Nseg] := X0 + Cell*(GlobI+Xx[SegB]);
             Y2^[Nseg] := Y0 + Cell*(GlobJ+Yy[SegB]);
          END
          ELSE BEGIN
             X1^[Nseg] := X0 + Cell*(GlobI+Xx[SegB]);
             Y1^[Nseg] := Y0 + Cell*(GlobJ+Yy[SegB]);
             X2^[Nseg] := X0 + Cell*(GlobI+Xx[SegA]);
             Y2^[Nseg] := Y0 + Cell*(GlobJ+Yy[SegA]);
      END;
END;
PROCEDURE SubTri(Side,Crnr1,Crnr2 : Word);
      BEGIN
      IF (l[Side]) THEN BEGIN
         IF (l[Crnr1]) THEN BEGIN
            AddSeg(Crnr1,5,Side,Crnr1);
         END ELSE IF (l[Crnr2]) THEN BEGIN
            AddSeg(5,Crnr2,Side,Crnr2)
         END ELSE IF (p[5]) THEN BEGIN
            AddSeg(Crnr1,Crnr2,Side,16+Side);
         END
      END ELSE IF (l[Crnr1]) THEN BEGIN
         IF (l[Crnr2]) THEN BEGIN
            AddSeg(5,Crnr2,Crnr1,Crnr2);
         END ELSE IF (p[Crnr2]) THEN BEGIN
             AddSeg(5,Crnr1,Crnr1,12+Side);
         END;
      END ELSE IF (l[Crnr2]) THEN BEGIN
         IF (p[Crnr1]) THEN BEGIN
            AddSeg(Crnr2,5,Crnr2,8+Side);
         END;
      END
      ELSE IF (p[Crnr1]) THEN BEGIN
         IF (p[Crnr2]) THEN BEGIN
            AddSeg(5,0,8+Side,12+Side);
         END;
      END
      ELSE IF (p[Crnr2]) THEN BEGIN
         IF (p[5]) THEN BEGIN
            AddSeg(Crnr1,0,12+Side,16+Side);
         END;
      END;
END;

PROCEDURE CtrCel;
   VAR
      i : Word;
   BEGIN
      Nsegs := 0;
      Gg[5] := (Gg[1]+Gg[2]+Gg[3]+Gg[4])*0.25;
      FOR i := 1 TO 5 DO
          p[i] := (Gg[0] = Gg[i]);
     Interp;
     SubTri(Top,   NE,NW);
     SubTri(Right, SE,NE);
     SubTri(Left,  NW,SW);
     SubTri(Bottom,SW,SE);
END;

{Within tests whether gg[0] lies between Max(gg[1..4]) and Min(gg[1..4]).
 If it does the function returns TRUE, 80287+specific}
{for a standard Pascal implementation see the second loop}

FUNCTION Within(VAR Gg;Pp : Pointer):Boolean;EXTERNAL;
{$L within}
PROCEDURE GenSegs(n : Word;p : Single;VAR f : AKArr;VAR Grid : AKMatrix);
   VAR
      GxMin0,GxMax0,GyMin0,GyMax0 : Word;
      k                           : Word;
   LABEL
        2,5;
   BEGIN
      Gg[0] := CtrVal(n,p,f);
      Nseg := 0;
      IF (Multiple) THEN BEGIN
         Gxmin0 := Nx;
         Gxmax0 := 1;
         Gymin0 := Ny;
         Gymax0 := 1;
      END;
      IF Test8087 > 1 THEN BEGIN
         FOR GlobI := Gxmin TO Gxmax DO BEGIN
             Pp := @Grid[GlobI,Gymin];      {point pp at Grid[i,gymin]}
             FOR  GlobJ := Gymin TO Gymax DO BEGIN
                 IF Within(Gg,Pp) THEN BEGIN       {by 4 to point at next GlobJ}
                    CtrCel;
                    IF (Multiple) THEN BEGIN
                        Gxmin0 := IntMin(Gxmin0,GlobI);
                        Gxmax0 := IntMax(Gxmax0,GlobI);
                        Gymin0 := IntMin(Gymin0,GlobJ);
                        Gymax0 := IntMax(Gymax0,GlobJ);
                    END;
                 END;
                 Inc(w,4);                  {w points at pp, increment offset}
             END;
         END;
      END
      ELSE BEGIN
         FOR GlobI := Gxmin TO Gxmax DO BEGIN
             FOR GlobJ := Gymin TO Gymax DO BEGIN
                 Gg[1] := Grid[Globi,Globj];
                 Gg[2] := Grid[Globi-1,Globj];
                 Gg[3] := Grid[Globi,Globj-1];
                 Gg[4] := Grid[Globi-1,Globj-1];
                 FOR k := 1 TO 4 DO BEGIN
                    IF (Gg[0] > Gg[k]) THEN GOTO 5
                 END;
                 GOTO 2;
         5:      FOR k := 1 TO 4 DO BEGIN
                    IF (Gg[0] < Gg[k]) THEN BEGIN
                       CtrCel;
                       IF (Multiple) THEN BEGIN
                          Gxmin0 := IntMin(Gxmin0,GlobI);
                          Gxmax0 := IntMax(Gxmax0,GlobI);
                          Gymin0 := IntMin(Gymin0,GlobJ);
                          Gymax0 := IntMax(Gymax0,GlobJ);
                       END;
                       GOTO 2;
                    END;
                 END;
        2:
            END;
         END;
    END;
    IF (Multiple) THEN BEGIN
       Gxmin := Gxmin0;
       Gxmax := Gxmax0;
       Gymin := Gymin0;
       Gymax := Gymax0;
    END;
END;
FUNCTION GetEpsilon(Nseg : Word;VAR X1,Y1 : AkArr): Single;
   CONST
        Eps0 = 1e-4;
   VAR
      ScaleX,ScaleY : Single;
   BEGIN
      ScaleX := Max(NSeg,X1)-Min(NSeg,X1);
      ScaleY := Max(NSeg,Y1)-Min(NSeg,Y1);
      IF ScaleX < ScaleY THEN
          GetEpsilon := ScaleX*Eps0
      ELSE
          GetEpsilon := ScaleY*Eps0;
END;

PROCEDURE Polys(VAR Poly        : PolyType;
                VAR X1,X2,Y1,Y2 : AkArr);
          VAR
             a                      : IntArr;
             b,
             BFlag                  : BoolArr;
             NMarrA,NmarrB          : IndxArr;
             Ptr,i,j,k,Ii,Jj,
             Nma,Nmb,J0,Ndx,
             Npts                   : Word;
             Dir                    : Integer;
             X2i,Y2i,X2ii,Y2ii,
             D2Min,D2,Epsilon       : Single;
      LABEL
           8,9,10,100,105,110,180,190,250,290,300;
      BEGIN
           WITH Poly DO BEGIN
                Npoly := 0;
                Npts  := 0;
                IF NSeg < 3 THEN Exit;
                QckSrt(Nseg,X1,Y1,X2,Y2);
                ZeroFill(a,SizeOf(a));
                ZeroFill(b,SizeOf(b));
                ZeroFill(Bflag,SizeOf(Bflag));
                Epsilon := GetEpsilon(NSeg,X1,Y1);
                j   := 1;
                Dir := 1;
                Nma := 0;
                FOR  i:=1 TO Nseg DO BEGIN
                    X2i := X2[i];
                    Y2i := Y2[i];
                   IF (Dir = 1) THEN BEGIN
        100:           IF (j <= Nseg) THEN BEGIN
                         IF (X2i > X1[j]) THEN BEGIN
                            Inc(j);
                            GOTO 100
                         END;
                       END;
                   END
                   ELSE WHILE (j >= 1) AND (X2i < X1[j]) DO
                           Dec(j);
                   J0 := j;
        110:       IF (j = 0) OR (j > Nseg) THEN BEGIN
                      Inc(Nma);
                      Nmarra[Nma] := i;
                      Dir := -Dir;
                      Inc(j,Dir);
                      GOTO 190
                   END
                   ELSE IF (Bflag[j]) THEN BEGIN
                        Inc(j,Dir);
                        GOTO 110
                   END
                   ELSE IF (i = j) THEN BEGIN
                        Inc(j,Dir);
                        GOTO 110
                   END
                   ELSE IF (X2i <> X1[j]) THEN BEGIN
                        Inc(Nma);
                        Nmarra[Nma] := i;
                        GOTO 180
                   END
                   ELSE IF (Y2i <> Y1[j]) THEN BEGIN
                        Inc(j,Dir);
                        GOTO 110
                   END
                   ELSE BEGIN
                        a[i] := j;
                        Bflag[j] := TRUE;
                   END;
        180:       IF (i < Nseg) THEN BEGIN
                      IF (X2i < X2[Succ(i)]) THEN BEGIN
                         IF (Dir = -1) THEN BEGIN
                            j := Succ(J0);
                            Dir := 1
                         END
                      END
                      ELSE IF (X2i > X2[Succ(i)]) THEN BEGIN
                           IF (Dir = 1) THEN BEGIN
                              j := Pred(J0);
                              Dir := -1;
                           END
                      END
                      ELSE
                         j := J0
                   END;
        190:    END;

                IF (Nma > 0) THEN BEGIN
                   Nmb := 0;
                   FOR i:=1 TO Nseg DO BEGIN
                       IF (Bflag[i] = FALSE) THEN BEGIN;
                          Inc(Nmb);
                          Nmarrb[Nmb] := i;
                       END;
                   END;
                   IF (Nmb > 0) THEN BEGIN
                      FOR i:=1 TO Nma DO BEGIN
                          Ii := Nmarra[i];
                          X2ii := X2[Ii];
                          Y2ii := Y2[Ii];
                          IF (Ii = Nmarrb[1]) THEN BEGIN
                             IF (Nmb = 1) THEN BEGIN
                                GOTO 290
                             END
                             ELSE BEGIN
                                  Ptr := 2;
                            END;
                          END
                          ELSE BEGIN
                               Ptr := 1;
                          END;
                          Ndx := Nmarrb[Ptr];
                          D2min := Sqr(X2ii-X1[Ndx]) + Sqr(Y2ii-Y1[Ndx]);
                          FOR j:=Succ(Ptr) TO Nmb DO BEGIN
                              Jj := Nmarrb[j];
                              IF (Jj <> Ii) THEN BEGIN
                                 D2 := Sqr(X1[Jj]-X2ii);
                                 IF (D2 < D2min) THEN BEGIN
                                    D2 := D2 + Sqr(Y1[Jj]-Y2ii);
                                    IF (D2 < D2min) THEN BEGIN
                                       D2min := D2;
                                       Ndx   := Jj;
                                       Ptr := j;
                                     END;
                                 END
                                 ELSE
                                     GOTO 250
                              END
                          END;
        250:              IF (D2min < Epsilon) THEN BEGIN
                             a[Ii] := Ndx;
                             Bflag[Ndx] := TRUE;
                             IF (Nmb > 1) THEN BEGIN
                                FOR k:=Ptr TO Pred(Nmb) DO BEGIN
                                    Nmarrb[k] := Nmarrb[Succ(k)];
                                END;
                                Dec(Nmb);
                             END;
                          END
                          ELSE
                              GOTO 300;
                      END;
        290:       END;
                END;
       300:
                FOR i:=1 TO Nseg DO BEGIN
                 IF (Bflag[i] = FALSE) THEN BEGIN
                    Inc(Npoly);
                    Inc(Npts);
                    Px[Npts] := X1[i];
                    Py[Npts] := Y1[i];
                    Ns[Npoly] := Npts;
                    Inc(NPts);
                    Px[Npts] := X2[i];
                    Py[Npts] := Y2[i];
                    PType[Npoly] := 1;
                    Ne[Npoly] := Npts;
                    j := i;
                    Bflag[i] := TRUE;
                    b[i] := TRUE;
          8:        IF (a[j] = 0) THEN GOTO 9;
                    j := a[j];
                    Inc(Npts);
                    Bflag[j] := TRUE;
                    b[j] := TRUE;
                    Px[Npts] := X2[j];
                    Py[Npts] := Y2[j];
                    Ne[Npoly] := Npts;
                    GOTO 8;
                 END;
          9:   END;
               FOR i:=1 TO Nseg DO BEGIN
                  IF (b[i] = FALSE) THEN BEGIN
                     Inc(NPoly);
                     PType[Npoly] := 0;
                     Inc(Npts);
                     Ns[Npoly] := Npts;
                     Px[Npts] := X1[i];
                     Py[Npts] := Y1[i];
                     b[i] := TRUE;
                     j := i;
         10:         j := a[j];
                     Inc(Npts);
                     Px[Npts] := X1[j];
                     Py[Npts] := Y1[j];
                     b[j] := TRUE;
                     IF (a[j] <> i) THEN GOTO 10;
                     Ne[Npoly] := Npts;
                  END;
                END;
         END;
END;

{GetArea performs the following loop in assembly language}

FUNCTION GetArea(Start,Stop : Word; VAR X,Y):Single; EXTERNAL;
{$L GetArea}
{
   VAR
      j    : Word;
      Area : Extended;
   begin
       Area := 0;
       for j:=Start+1 to Stop do
            Area := Area + (x[j-1]-x[j])*(y[j-1]+y[j]);
      GetArea := Area;
end;
}

PROCEDURE Areas(VAR  Poly       : PolyType);
      VAR
         i,J0,J1 : Word;
      BEGIN
          WITH Poly DO BEGIN
               Area := 0;
               FOR i:=1 TO Npoly DO BEGIN
                  J0 := Ns[i];
                  J1 := Ne[i];
                  IF Integer(J1) - Integer(J0) > 1 THEN BEGIN
                     Area := Area + GetArea(J0,J1,Px,Py);
                     IF (PType[i] = 0) THEN
                        Area := Area + (Px[J1]-Px[J0])*(Py[J1]+Py[J0]);
                  END;
               END;
               Area := Area * 0.5;
          END;
END;
PROCEDURE MakeAContour(    n                 : Word;
                           ContVal           : Single;
                       VAR Poly              : PolyType;
                       VAR g                 : AKMatrix);
          BEGIN
               GenSegs(n,ContVal,f^,G);
               Polys(Poly,X1^,X2^,Y1^,Y2^);
               Areas(Poly);
END;
PROCEDURE InitContour(        n       : Word;
                          VAR x,y     : AkArr;
                          VAR G       : AkMatrix);

          BEGIN
               IF NOT SpaceUsed THEN BEGIN
                  New(f);
                  New(X1);
                  New(X2);
                  New(Y1);
                  New(Y2);
                  SpaceUsed := TRUE;
               END;
               SetCtr(n,x,y,f^,G);
               ShellSort(n,f^,FALSE);
               GxMin := 1;
               GxMax := Nx;
               GyMin := 1;
               GyMax := Ny;

END;
PROCEDURE DisposeContour;
          BEGIN
               IF SpaceUsed THEN BEGIN
                  Dispose(f);
                  Dispose(X1);
                  Dispose(X2);
                  Dispose(Y1);
                  Dispose(Y2);
                  SpaceUsed := FALSE;
               END;
END;
(*
Procedure GetContourLimits(    n           : Word;
                           VAR x,y         : AkArr;
                               p           : Single;
                           VAR G           : AkMatrix;
                           VAR x1,y1,x2,y2 : Word);
          VAR
             f     : AkArrPtr;
             i,j,k : Word;
             pp    : Pointer;
             w     : Word absolute pp;
          label
               2,5;
          begin
               New(f);
               SetCtr(n,x,y,f^,G);
               ShellSort(n,f^,False);
               gg[0] := CtrVal(n,p,f^);
               x1 := nx;
               x2 := 1;
               y1 := ny;
               y2 := 1;
               If Test8087 > 1 then begin
                  for i := 1 to nx do begin
                      pp := @G[i,1];
                      for j := 1 to ny do begin
                              TransferGrid{(gg[1],pp)};
                              inc(w,4);
                              if Within then begin
                                 x1 := Min0(x1,i);
                                 x2 := Max0(x2,i);
                                 y1 := Min0(y1,j);
                                 y2 := Max0(y2,j);
                              END;
                         end;
                end;
             end
             else begin
                  for I := 1 to nx do begin
                     pp := @G[I,1];
                     For J := 1 to ny do begin
                         TransferGrid{(gg[1],pp)};
                         inc(w,4);
                         for k := 1 to 4 do begin
                             IF (gg[0] > gg[k]) then GOTO 5
                         end;
                         GOTO 2;
                 5:      for k := 1 to 4 do begin
                             IF (gg[0] < gg[k]) THEN begin
                                x1 := Min0(x1,i);
                                x2 := Max0(x2,i);
                                y1 := Min0(y1,j);
                                y2 := Max0(y2,j);
                             END;
                             GOTO 2;
                         end;
                     end;
           2:
                  end;
             end;
             Dispose(f);
             dec(x1);
             dec(y1);
END;
*)
BEGIN
END.


