{$A+,B-,D+,E-,F-,I-,L+,N+,O-,R-,S-,V-}
{$M 64384,0,655360}

UNIT FILEIN;

INTERFACE

USES GlobType,IOLib,WindLib,Crt,ScrLib,Utility;

TYPE
    StartStop = Array[1..2] OF Byte;
    IORecord  = RECORD
                     Printer           : Byte;
                     IOArr             : Array[1..6] OF StartStop;
                     Size              : Single;
                     {Name,Mo,Da,Yr,X,Y}
                END;
VAR
   GlobIO : IORecord;

PROCEDURE Input(VAR IOParams : IORecord);
PROCEDURE GetFileInput(VAR IOParams : IORecord);
PROCEDURE ReadPtsFile(VAR FileName   : String;
                      VAR X,Y        : Arr;
                      VAR StrArr     : String8Arr;
                      VAR BirdName   : DataIndex;
                      VAR n          : Word;
                      VAR FileOk     : Boolean);

IMPLEMENTATION

PROCEDURE WindowWrite(x,y,Color : Byte;St : String);
          BEGIN
               VarFWrite(GetScrPos(Lo(WindMin)+x,Hi(WindMin)+y),Color,St);
END;
PROCEDURE WriteStartStop(St : String;Pos,Range : StartStop;Color : Byte);
          CONST
               Start    : String[16]  = '   Start Col. = ';
               Stop     : String[16]  = '   Stop Col.  = ';
          VAR
             Posit : Word;
         BEGIN
               Posit := GetScrPos(Lo(WindMin)+Pos[1],Hi(WindMin)+Pos[2]);
               VarFWrite(Posit,Color,St);
               VarFWrite(Posit+160,Color,Start);
               VarFWrite(Posit+320,Color,Stop);
               Pos[1] := Pos[1] + 18;
               Inc(Pos[2]);
               GotoXY(Pos[1],Pos[2]);
               Write(Range[1]:3);
               Inc(Pos[2]);
               GotoXY(Pos[1],Pos[2]);
               Write(Range[2]:3);
END;
FUNCTION GetYN(x,y : Byte):Char;
         VAR
            Ch,Ch2 : Char;
         BEGIN
              GotoXY(x,y);
              REPEAT
                  GetKeys(Ch,Ch2);
                  Ch := UpCase(Ch);
               UNTIL Ch IN ['Y','N',#27];
              GetYN := Ch;
              Write(Ch);
END;
PROCEDURE GetStartStop(    Field          : Byte;
                           Pos            : StartStop;
                       VAR Range          : StartStop;
                       VAR EscSw          : Boolean);
          VAR
             X1,X2 : Integer;
             x,y   : Byte;
          BEGIN
               Pos[1] := Pos[1] + 18;
               Inc(Pos[2]);
               X1 := Range[1];
               X2 := Range[2];
               EscSw := InputInteger(Pos[1],Pos[2],3,1,255,X1);
               IF EscSw THEN Exit;
               EscSw := InputInteger(Pos[1],Pos[2]+1,3,X1,X1 + Field,X2);
               IF EscSw THEN Exit;
               Range[1] := X1;
               Range[2] := X2;
END;
PROCEDURE PrinterMenu(VAR Printer : Byte;VAR EscSw : Boolean);
                VAR
                   x : Integer;
                BEGIN
                     x := Printer;
                     
                     EscSw := InputInteger(19,16,1,0,2,x);
                     IF NOT EscSw THEN
                        Printer := x;
END;
PROCEDURE WriteYN(x,y,YN :  Byte);
          BEGIN
               IF YN <> 0 THEN
                  WindowWrite(x,y,RevVid3,'Y')
               ELSE
                   WindowWrite(x,y,RevVid3,'N');
END;
PROCEDURE Input(VAR IOParams : IORecord);
          CONST
                OutLocs    : Array[1..6] OF StartStop =
                           ((1,3),(30,3),(30,6),(30,9),(1,7),(1,10));
                TextArr    : Array[1..6] OF String[5] =
                           ('Name','Month','Day','Year','X','Y');

          LABEL
               CloseWindow;
          VAR
             OutFile   : File OF IORecord;
             Ptr,Ptr2  : Pointer;
             IORes     : IORecord;
             Ct        : Word;
             Ch,Ch2    : Char;
             EscSw     : Boolean;
             SaveAtt   : Byte;
          BEGIN
            IORes := IOParams;
            SetCursorSize(Cursor);
            WITH IORes DO BEGIN
               SaveAtt := TextAttr;
               TextAttr := RevVid2;
               OpenTextWindow(Ptr,3,3,56,22,RevVid2,RevVid3,BoxExt1,TRUE);
               WindowWrite(1,1,RevVid2,'Input bird name ? (Y/N) : ');
               WriteYN(27,1,IOArr[1,1]);
               WindowWrite(30,1,RevVid2,'Input date ? (Y/N) : ');
               WriteYN(51,1,IOArr[2,1]);
               FOR Ct := 1 TO 6 DO
                   WriteStartStop(TextArr[Ct],OutLocs[Ct],IOArr[Ct],RevVid3);
               WindowWrite(1,14,RevVid3,'Unit size (m) = ');
               GotoXY(17,14);
               Write(Size:5:2);
               SlowWrite(1,16,'Choose a printer: ');
               Write(Printer);
               SlowWrite(3,17,'0 = None, 1 = Epson, 2 = HP Laser');
               Ch := GetYN(27,1);
               CASE Ch OF
                       'Y' : BEGIN
                                  GetStartStop(2,OutLocs[1],IOArr[1],EscSw);
                                  IF EscSw THEN GOTO CloseWindow;
                             END;
                       'N' : IOArr[1,1] := 0;
                       #27 : BEGIN
                                  GOTO CloseWindow;
                             END;
               END;
               Ch := GetYN(51,1);
               CASE Ch OF
                       'Y' : BEGIN
                                  FOR Ct := 2 TO 4 DO BEGIN
                                      GetStartStop(1,OutLocs[Ct],IOArr[Ct],EscSw);
                                      IF EscSw THEN GOTO CloseWindow;
                                  END;
                             END;
                       'N' : IOArr[2,1] := 0;
                       #27 : BEGIN
                                  GOTO CloseWindow;
                             END;
               END;
               FOR Ct := 5 TO 6 DO BEGIN
                   GetStartStop(20,OutLocs[Ct],IOArr[Ct],EscSw);
                   IF EscSw THEN GOTO CloseWindow;
               END;
               EscSw := InputSingle(17,14,6,2,0,100,Size);
               IF EscSw THEN GOTO CloseWindow;
               PrinterMenu(Printer,EscSw);
               IF EscSw THEN GOTO CloseWindow;
               OpenOneLineWindow(Ptr2,20,20,ErrorVid,ErrorVid,BoxExt2,
                             'Save changes to file? (Y/N)',TRUE);
              Ch := ReturnYesNo;
              IF Ch = 'Y' THEN BEGIN
                 Assign(OutFile,'Sch10_28.SET');
                 ReWrite(Outfile);
                 Write(OutFile,IORes);
                 Close(Outfile);
                 Ct := IOResult;       {Catch error}
              END;
              RestoreWindow(Ptr2);
              IOParams := IORes;
              InputScale := Sqr(100/IORes.Size);
           CloseWindow:
              SetCursorSize(NoCursor);
              Window(1,1,80,25);
              RestoreWindow(Ptr);
              TextAttr := SaveAtt;
            END;
END;
PROCEDURE GetFileInput(VAR IOParams : IORecord);
          CONST
               IOConst     : IORecord = (Printer : 2;
                                         IOArr   : ((1,3),(15,16),(11,12),
                                                    (20,21),(48,53),(55,61));
                                         Size    : 10.0);
          VAR
             InFile : File OF IORecord;
          BEGIN
               Assign(InFile,'Sch10_28.SET');
               Reset(InFile);
               Read(InFile,IOParams);
               Close(InFile);
               IF IOResult <> 0 THEN
                  IOParams := IOConst;
END;
PROCEDURE ReadWord(VAR St           : String;
                       Start,Stop   : Byte;
                   VAR Int          : Word;
                   VAR Error        : Boolean);
          VAR
             s      : Integer;
             TempSt : String[5];
             i,Ct   : Byte;
          BEGIN
               i := 0;
               IF Stop > Byte(St[0]) THEN
                  Stop := Byte(St[0]);
               FOR Ct := Start TO Stop DO BEGIN
                   IF St[Ct] <> #32 THEN BEGIN
                      Inc(i);
                      TempSt[i] := St[Ct];
                   END;
               END;
               TempSt[0] := Char(i);
               Val(TempSt,Int,s);
               Error := S <> 0;
END;
PROCEDURE ReadSingle(VAR St           : String;
                         Start,Stop   : Byte;
                     VAR Sing         : Single;
                     VAR Error        : Boolean);
          VAR
             s      : Integer;
             TempSt : String[30];
             i,Ct   : Byte;
          BEGIN
               IF Stop > Byte(St[0]) THEN
                  Stop := Byte(St[0]);
               i := 0;
               FOR Ct := Start TO Stop DO BEGIN
                   IF St[Ct] <> #32 THEN BEGIN
                      Inc(i);
                      TempSt[i] := St[Ct];
                   END;
               END;
               TempSt[0] := Char(i);
               IF TempSt[1] = '.' THEN
                  TempSt := '0' + TempSt;
               Val(TempSt,Sing,s);
               Error := S <> 0;
END;
PROCEDURE ReadString(VAR St           : String;
                         Start,Stop   : Byte;
                   VAR   TempSt       : String;
                   VAR Error        : Boolean);
          VAR
             i,Ct   : Byte;
          BEGIN
               TempSt[0] := #0;
               i := 0;
               FOR Ct := Start TO Stop DO BEGIN
                      Inc(i);
                      TempSt[i] := St[Ct];
               END;
               TempSt[0] := Char(i);
               Error := Ct > Byte(St[0]);
END;

{MakeDate creates a date string from 3 numbers}

FUNCTION MakeDate(m,d,y : Word):String;
         VAR
            St,St2 : String[10];
         BEGIN
              St2 := '';
              Str(m,St);
              IF m < 10 THEN
                 St2 := St2 + '0';
              St2 := St2 + St + '/';
              Str(d,St);
              IF d < 10 THEN
                 St2 := St2 + '0';
              St2 := St2 + St + '/';
              Str(y,St);
              IF y < 10 THEN
                 St2 := St2 + '0';
              St2 := St2 + St;
              MakeDate := St2;
END;


PROCEDURE ReadPtsFile(VAR FileName   : String;
                      VAR X,Y        : Arr;
                      VAR StrArr     : String8Arr;
                      VAR BirdName   : DataIndex;
                      VAR n          : Word;
                      VAR FileOk     : Boolean);
VAR
   a                      : Text;
   Ptr,Ptr2               : Pointer;
   Ct                     : Word;
   St,OldSt               : String[3];
   Line                   : String;
   FileError              : Boolean;
   Mo,Day,Yr              : Word;
   Xx,Yy                  : Single;
LABEL
     FileDone;
BEGIN
     Wait(Ptr2);
     GetMem(Ptr,30000);
     FillWord(BirdName,SizeOf(BirdName),65535);
     FileOK := TRUE;
     Assign(a,FileName);
     Reset(a);
     SetTextbuf(a,Ptr^,30000);
     IF IOResult <> 0 THEN BEGIN
        WindowErrors(18);
        FileOk := FALSE;
        Exit;
     END;
     n         := 0;
     FileError := FALSE;
     OldSt := '';
     BirdName[0] := 0;
     WHILE NOT EOF(a) AND NOT FileError DO BEGIN
           ReadLn(a,Line);
           FileError := (IOresult <> 0);
           IF FileError THEN GOTO FileDone;
           Inc(n);
           IF n > MaxPts THEN BEGIN
             FileOk := FALSE;
             WindowErrors(100);
             GOTO FileDone;
            END;
            IF GlobIO.IOArr[1,1] <> 0 THEN BEGIN
               ReadString(Line,GlobIO.IOArr[1,1],GlobIO.IOArr[1,2],
                          St,FileError);
               IF FileError THEN BEGIN
                  Dec(n);
                  GOTO FileDone;
               END;
               IF (St <> OldSt) THEN BEGIN
                  Inc(BirdName[0]);
                   BirdName[BirdName[0]] := n;
                   BirdNameSt[BirdName[0]] := St;
                   OldSt := St;
                END;
            END
            ELSE BEGIN
                 BirdName[0] := 1;
                 BirdName[1] := 1;
                 BirdNameSt[1] := '001';
            END;
            IF GlobIO.IOArr[2,1] <> 0 THEN BEGIN
               ReadWord(Line,GlobIO.IOArr[2,1],GlobIO.IOArr[2,2],
                              Mo,FileError);
               IF FileError THEN BEGIN
                  Dec(n);
                  GOTO FileDone;
               END;
               ReadWord(Line,GlobIO.IOArr[3,1],GlobIO.IOArr[3,2],
                        Day,FileError);
               IF FileError THEN BEGIN
                  Dec(n);
                  GOTO FileDone;
               END;
               ReadWord(Line,GlobIO.IOArr[4,1],GlobIO.IOArr[4,2],
                            Yr,FileError);
               IF FileError THEN BEGIN
                  Dec(n);
                  GOTO FileDone;
               END;
               StrArr[n] := MakeDate(Mo,Day,Yr);
          END
          ELSE
             StrArr[n] := '00/00/00';
          ReadSingle(Line,GlobIO.IOArr[5,1],GlobIO.IOArr[5,2],
                      Xx,FileError);
          IF FileError THEN BEGIN
                  Dec(n);
                  GOTO FileDone;
          END;
          ReadSingle(Line,GlobIO.IOArr[6,1],GlobIO.IOArr[6,2],
                         Yy,FileError);
          IF FileError THEN BEGIN
                  Dec(n);
                  GOTO FileDone;
          END;
          x[n] := Xx;
          y[n] := Yy;
     END;
     FileDone:
     Close(a);
     IF N < 5 THEN BEGIN
        FileOk := FALSE;
        WindowErrors(101);
     END;
     FreeMem(Ptr,30000);
     RestoreWindow(Ptr2);
END;
BEGIN
     GetFileInput(GlobIO);
END.

