{$A+,B-,D+,E-,F-,I-,L+,N+,O-,R-,S-,V-}
{$M 64384,0,655360}
UNIT FileOut;

INTERFACE

USES GlobType,Menu123,ScrLib,Crt,IOLib,WindLib,AkLib,ContLib,Linlib,
     MCP,JenStat,FileIn;

PROCEDURE DoOutputMenu(n : Word;VAR x,y : Arr);

IMPLEMENTATION

{Menus here as DSC}

{Once you have the basic setup, you can whip out menus}

  CONST
       MCPConst = 1;
       JTConst  = 2;
       AKConst  = 3;
       DOSEOL  = #13#10;
       UNIXEOL = #10;
       OutMenu : Menu =
                  (FirstLine : ('J/T','MCP','AK','UNIX/DOS',
                                'Quit','','','');
                  SecondLine : ('Output Jennrich-Turner contour',
                                'Output Minimum Convex Polygon coordinates',
                                'Output Adaptive Kernel contour',
                                'Toggle output between UNIX and DOS format',
                                'Exit menu','','','');
                  FstCharSet   : 'JMAUQ';
                  Locations    : (0,0,0,0,0,0,0,0);
                  EntryNo      : 5;
                  Position     : 1;     {initialize bar to start at position 1}
                  TopLineAtt   : 7;     {start with monochrome colors}
                  BotLineAtt   : 15;
                  FstCharAtt   : 15;
                  LightBar     : 112;
                  FirstBar     : 1);
OutputColors : ColorSet123 = (63,112,60,31,28);
Unix : Boolean = FALSE;
FUNCTION WriteFile(VAR Outfile : Text;St : String;UnixSw : Boolean):Boolean;
         VAR
            Error : Integer;
        BEGIN
             IF UnixSW THEN
                  Write(OutFile,St,UNIXEOL)
               ELSE
                   Write(OutFile,St,DOSEOL);
             Error := IOResult;
             WriteFile := Error <> 0;
END;
PROCEDURE FileOutput(    Start,Stop,
                         PolyNo        : Word;
                     VAR Outfile       : Text;
                     VAR X,Y           : AkArr;
                         Unix          : Boolean;
                     VAR Error         : Boolean);
          VAR
              Ct : Word;
              EOL : String[2];
              PolySt : String[3];
              Scaler : Single;
          BEGIN
               Scaler := GlobIO.Size;
               IF Unix THEN
                  EOL := UNIXEOL
               ELSE
                   EOL := DOSEOL;
               IF (Stop - Start) > 0 THEN BEGIN
                  Str(PolyNo,Polyst);
                  Error := WriteFile(OutFile,PolySt,Unix);
                  IF Error THEN Exit;
                  FOR Ct := Start TO Stop DO BEGIN
                     Write(OutFile,Scaler*X[Ct]:20:3,Scaler*Y[Ct]:20:3,EOL);
                     Error := IOResult <> 0;
                     IF Error THEN
                        Exit;
                  END;
                  Write(OutFile,Scaler*X[Start]:20:3,Scaler*Y[Start]:20:3,EOL);
                  Write(OutFile,'END',EOL);
               END;
END;
PROCEDURE OutputAk(VAR Poly       : PolyType;
                   VAR OutFile    : Text;
                       Unix       : Boolean;
                   VAR Error      : Boolean);
          VAR
             Ct : Word;
         BEGIN
              WITH Poly DO BEGIN
                   FOR Ct := 1 TO NPoly DO BEGIN
                       FileOutput(Ns[Ct],Ne[Ct],Ct,OutFile,Px,Py,
                                  Unix,Error);
                   END;
              END;
END;
PROCEDURE DoContour(    n                       : Word;
                    VAR Poly                    : PolyType;
                    VAR x,y                     : AkArr;
                        ContLevel               : Single);
          VAR
             Grid : AkMatPtr;
          BEGIN
               New(Grid);
               DoAK(n,x,y,Grid^);
               InitContour(n,x,y,Grid^);
               MakeAContour(n,ContLevel,Poly,Grid^);
               DisposeContour;
               Dispose(Grid);
END;
PROCEDURE GetAK(    n              : Word;
                VAR X,Y            : AkArr;
                VAR OutFile        : Text;
                    Level          : Single;
                    Unix           : Boolean;
                VAR Error          : Boolean);
          VAR
             Poly : PolyPtr;
             Ct   : Word;
          BEGIN
               New(Poly);
               DoContour(n,Poly^,x,y,Level);
               OutputAk(Poly^,OutFile,Unix,Error);
               Dispose(Poly);
END;
PROCEDURE GetMCP(    n               : Word;
                 VAR X,Y             : AkArr;
                 VAR OutFile         : Text;
                     Unix            : Boolean;
                 VAR Error           : Boolean);
          VAR
             NewN : Word;
             Area : Single;
          BEGIN
               MakeMCP(n,X,Y,NewN,Area);
               FileOutput(1,NewN,1,OutFile,X,Y,Unix,Error);
END;
PROCEDURE GetJT(    n                               : Word;
                VAR X,Y                             : AkArr;
                VAR OutFile                         : Text;
                    Level                           : Word;
                    Unix                            : Boolean;
                VAR Error                           : Boolean);
          BEGIN
               JennrichContour(n,X,Y,Level);
               FileOutput(1,N,1,OutFile,X,Y,Unix,Error);
END;
PROCEDURE Output(    n              : Word;
                 VAR X,Y            : AkArr;
                     IOType         : Byte;
                     Level          : Single;
                     LevelNo        : Word;
                     Unix           : Boolean;
                 VAR Error          : Boolean);
          VAR
             St         : String;
             FileName   : String;
             OutFile    : Text;
             Ptr,Ptr2   : Pointer;
             Holder     : Byte;
             IORes      : Integer;
          LABEL
               Finis;
          BEGIN
               FileName := 'Contour.out';
               Holder := TextAttr;
               TextAttr := RevVid3;
               OpenTextWindow(Ptr,10,5,70,9,RevVid,Revvid3,BoxExt1,TRUE);
               SetCursorSize(Cursor);
               REPEAT
                   SlowWrite(1,2,'The output file :                                ');
                   Error := InputText(19,2,30,FileName);
                   IF Error THEN GOTO Finis;
                   Assign(OutFile,FileName);
                   ReWrite(OutFile);
                   IORes := IOResult;
                   IF IoRes <> 0 THEN
                      WindowErrors(102);
               UNTIL (IORes = 0);
               Wait(Ptr2);
               CASE IOType OF
                    MCPConst  : GetMCP(n,X,Y,OutFile,Unix,Error);
                    JTConst   : GetJT(n,X,Y,OutFile,LevelNo,Unix,Error);
                    AKConst   : GetAK(n,X,Y,OutFile,Level,Unix,Error);
               END;
               Error := WriteFile(OutFile,'END',Unix);
               IF Error THEN
                  WindowErrors(102);
               Close(Outfile);
               Error := IOResult <> 0;
               RestoreWindow(Ptr2);
               Finis:
               RestoreWindow(Ptr);
               TextAttr := Holder;
               SetCursorSize(NoCursor);
               Window(1,1,80,25);
END;
PROCEDURE UnixDos(VAR Ptr : Pointer;Toggle : Boolean);
          VAR
             St : String[4];
          BEGIN
               IF Toggle THEN
                   Unix := NOT Unix;
               IF Unix THEN
                  St := 'UNIX'
               ELSE
                   St := 'DOS';
               RestoreWindow(Ptr);
               OpenOneLineWindow(Ptr,35,10,RevVid2,RevVid3,BoxExt1,St,TRUE);
END;
FUNCTION HomeRangeWindow(Start,n : Byte;St : String; VAR EscSw : Boolean) : Byte;
         CONST
              HomeRangeSize : Array[1..6] OF String[20] =
                                ('1.00 Polygon',
                                 '0.95 Contour',
                                 '0.90 Contour',
                                 '0.75 Contour',
                                 '0.50 Contour',
                                 '0.20 Contour');
         VAR
             Ct,i   : Word;
             Ptr    : Pointer;
             Holder : Byte;
             Res    : Integer;
          BEGIN
               Holder := TextAttr;
               TextAttr := RevVid3;
               OpenTextWindow(Ptr,10,5,35,16,RevVid,Revvid3,BoxExt1,TRUE);
               GotoXY(1,1);
               Write(St);
               GotoXY(1,3);
               i := 0;
               TextAttr := RevVid2;
               FOR Ct := Start TO n DO BEGIN
                   Inc(i);
                   WriteLn(i,'. ',HomeRangeSize[Ct]);
               END;
               SlowWrite(1,9,'Choose a number:');
               SetCursorSize(Cursor);
               EscSw := InputInteger(20,9,1,1,Succ(n)-Start,Res);
               HomeRangeWindow := Res;
               Window(1,1,80,25);
               RestoreWindow(Ptr);
               SetCursorSize(NoCursor);
               TextAttr := Holder;
END;
FUNCTION OutType(Ch : Char): Byte;
         BEGIN
            CASE Ch OF
                 'J' : OutType := JTConst;
                 'M' : OutType := MCPConst;
                 'A' : OutType := AKConst;
            END;
END;
PROCEDURE GetStats(    Ch          : Char;
                       Result      : Byte;
                       n           : Word;
                   VAR x,y         : Arr;
                   VAR Error       : Boolean);
            VAR
               XX,YY : AkArrPtr;
            BEGIN
                 New(Xx);
                 New(Yy);
                 MoveRow(x,Xx^,n);
                 MoveRow(y,Yy^,n);
                 Output(n,Xx^,Yy^,OutType(Ch),ContVect[Result],Result,Unix,Error);
                 Dispose(Xx);
                 Dispose(Yy);
END;
PROCEDURE DoOutputMenu(n : Word;VAR X,Y : Arr);
          VAR
             Ch         : Char;
             UnixPtr    : Pointer;
             ScreenArea : Array[0..3999] OF Byte;
             Result     : Byte;
             EscSw      : Boolean;
          LABEL
               Finis;
          BEGIN
               BlockFromScreen(ScreenArea,0,2000);
               CharToScreen(0,1840,'',Video3);
               UnixPtr := NIL;
               UnixDos(UnixPtr,FALSE);
               REPEAT
                     Ch := DoMenu123(OutMenu,OutputColors);
                     CASE Ch OF
                          'J' : BEGIN
                                    Result := HomeRangeWindow(2,4,
                                                 'Jennrich Turner',EscSw);
                                    IF EscSw THEN GOTO Finis;
                                END;
                          'M' : BEGIN
                                     Result := HomeRangeWindow(1,1,
                                                 'Minimum Convex Polygon',EscSw);
                                    IF EscSw THEN GOTO Finis;
                                END;
                          'A' : BEGIN
                                     Result := HomeRangeWindow(2,6,
                                                 'Adaptive Kernel',EscSw);
                                    IF EscSw THEN GOTO Finis;
                                END;
                          'U' : BEGIN
                                     UnixDos(UnixPtr,TRUE);
                                END;
                     END;
                   IF Ch IN ['M','A','J'] THEN
                      GetStats(Ch,Result,n,X,Y,EscSw);

              Finis:
              UNTIL Ch IN ['Q',#27];
              RestoreWindow(UnixPtr);
              BlockToScreen(ScreenArea,0,2000);
END;
BEGIN
END.
