UNIT GetFile;

INTERFACE


PROCEDURE ChangeFileName;
PROCEDURE WritePath;
PROCEDURE SelectFile(VAR FileName     : String;
                     VAR FileSelected : Boolean;
                         Shadow       : Boolean);

IMPLEMENTATION

USES DOS,Menu123,FileDisp,WindLib,Crt,ScrLib,IOLib,Utility;

TYPE
   PathString      = String[80];
   FileString      = String[12];
   NameString      = String[8];
   ExtensionString = String[4];
   DirString       = String[67];

VAR
   CurrentFile,
   CurrentTemplate : PathString;
   HomeDir         : DirString;
   Ch              : Char;
   Ct, Loc, Page   : Word;
CONST
FilesMenu : Menu =
                  (FirstLine : ('File','Exit','Cancel',
                                '','','','','');
                  SecondLine : ('Select a file','Exit program with file name',
                                'Exit program without file name',
                                '','','','','');
                  FstCharSet   : 'FEC';
                  Locations    : (0,0,0,0,0,0,0,0);
                  EntryNo      : 3;
                  Position     : 1;     {initial position}
                  TopLineAtt   : 7;     {start with monochrome colors}
                  BotLineAtt   : 15;
                  FstCharAtt   : 15;
                  LightBar     : 112;
                  FirstBar     : 1);
FilesMenuColors : ColorSet123 = (63,112,60,31,28);


{GetNewTemplate just opens a window, gets the template, and closes the window}

PROCEDURE GetTemplate(VAR Template : String; VAR Aborted : Boolean);
   VAR
      DPtr   : Pointer;
      Holder : PathString;

   BEGIN
      OpenTextWindow(DPtr,2,5,79,9,112,31,BoxExt1,FALSE);
      TextAttr := Video2;
      GoToXY(2,1);
      WriteLn('Enter the file name-- may include path/template, wildcards');
      WriteLn(' <CR> uses current template, 0\ uses home directory, <ESC> aborts');
      SetCursorSize(Cursor);
      Aborted := InputText(2,3,79,Holder);
      Window(1,1,80,25);
      SetCursorSize(NoCursor);
      IF NOT Aborted THEN
         UpCaseSt(Holder,Template);
      RestoreWindow(DPtr);
   END;

FUNCTION WildCardsIn(Template : String) : Boolean;
   BEGIN
      WildCardsIn := NOT((CharPos('?',Template)=0) AND
                         (CharPos('*',Template)=0));
   END;

PROCEDURE AdjustDir(VAR Dir : String);
   VAR
      OldDir  : DirString;
      OldName : NameString;
      OldExt  : ExtensionString;

   BEGIN
      IF (Copy(Dir,1,1) <> '\') AND (Copy(Dir,2,1) <> ':') THEN      {Root}

         IF Copy(Dir,1,2) = '0\' THEN           {path = '0' -> home directory}
            Dir := HomeDir + Copy(Dir,3,Length(Dir)-2)   {Save rest, if any}

         ELSE BEGIN                                    {Append to current path}
            FSplit(CurrentFile,OldDir,OldName,OldExt);
            Dir := OldDir + Dir;
         END;
      Dir := FExpand(Dir);
   END;

PROCEDURE AdjustName(VAR Name, Ext : String);
   BEGIN
      IF Name = '' THEN
         Name := '*';
      IF Ext = '' THEN
         Ext := '.*';
   END;
PROCEDURE AdjustTemplate(VAR Template : String);
   VAR
      Dir  : DirString;
      Name : NameString;
      Ext  : ExtensionString;

   BEGIN
      FSplit(Template,Dir,Name,Ext);
      AdjustDir(Dir);
      AdjustName(Name,Ext);
      Template := Dir+Name+Ext;
   END;

PROCEDURE ChooseFile(Template : String; VAR FileSelected : Boolean;Shadow : Boolean);
   VAR
      Result            : Byte;
      NewFile           : FileString;
      Dir               : DirString;
      Name              : NameString;
      Ext               : ExtensionString;
      TempLoc, TempPage : Word;
      TempTemplate      : PathString;

   BEGIN
      TempLoc := Loc;
      TempPage := Page;
      AdjustTemplate(Template);
      IF Template <> CurrentTemplate THEN BEGIN
         Loc := 1;
         Page := 1;
      END;
      ScrollingFileList(Template,NewFile,Page,Loc,Result,Shadow);
      SetCursorSize(NoCursor);
      IF Result = 1 THEN BEGIN
         FSplit(Template,Dir,Name,Ext);
         IF WildCardsIn(Template) THEN
            CurrentTemplate := Template;
         CurrentFile := Dir + NewFile;
         FileSelected := TRUE;
      END
      ELSE IF Result = 3 THEN BEGIN
         Loc := TempLoc;
         Page := TempPage;
      END;
   END;
PROCEDURE InputFileName(VAR FileSelected : Boolean;Shadow : Boolean);
   VAR
      Template     : PathString;
      Dir          : DirString;
      Name         : NameString;
      Ext          : ExtensionString;
      SearchResult : SearchRec;
      Aborted      : Boolean;

   BEGIN
      GetTemplate(Template,Aborted);
      IF Aborted THEN
         EXIT;

      IF Template = '' THEN
         Template := CurrentTemplate

     {If template ends with '\', it's a directory-- add on wildcards}
      ELSE IF Copy(Template,Length(Template),1) = '\' THEN
         Template := Template + '*.*';

     {If there are wildcards it's (now) a file}
      IF WildCardsIn(Template) THEN BEGIN
         ChooseFile(Template,FileSelected,Shadow);
         EXIT;
      END;

     {No wildcards? Assume directory. Chances are it'll turn out to be a}
     {file, but the file routine may alter the template, so we'll look for a}
     {directory first, and if unsuccessful we'll go for the file.}
      AdjustDir(Template);
      FindFirst(Template,Directory,SearchResult);
      IF (DOSError = 0) AND (SearchResult.Attr = $10) THEN BEGIN
         ChooseFile(Template+'\*.*',FileSelected,Shadow); {Directory was found}
         EXIT;
      END;

      {3) It must be a file name}
      AdjustTemplate(Template);
      IF WildCardsIn(Template) THEN BEGIN   {Wildcards may have been added on}
         ChooseFile(Template,FileSelected,Shadow);
         EXIT;
      END;

     {We're down to the last possibility-- a fully specified file name. If we
      can't find it then print an error.}
      FindFirst(Template,AnyFile,SearchResult);
      IF DOSError = 0 THEN BEGIN
         CurrentFile     := Template;
         CurrentTemplate := Template;
         FileSelected    := TRUE;
      END
      ELSE
         WindowErrors(4);
   END;
PROCEDURE WritePath;
          VAR
               d : DirStr;
               n : NameStr;
               e : ExtStr;
          BEGIN
               FSplit(CurrentFile,d,n,e);
               d := 'The file: '+ n + e;
               ClearLine(24);
               ClearLine(25);
               VarFWrite(3680,Video1,CurrentTemplate);
               VarFWrite(3840,ErrorVid,d);
END;
PROCEDURE SelectFile(VAR FileName     : String;
                     VAR FileSelected : Boolean;
                         Shadow       : Boolean);
   BEGIN
        TextAttr := 7;
        FileSelected := FALSE;
        SetColors;
        SetCursorSize(NoCursor);
        InputFileName(FileSelected,Shadow);
        IF FileSelected THEN
           FileName := CurrentFile;           {Return with new file name}
   END;
PROCEDURE ChangeFileName;
          BEGIN
               CurrentFile     := HomeDir + '???';
               CurrentTemplate := HomeDir + '*.*';
               Loc := 1;
               Page := 1;
END;
BEGIN
   Loc  := 1;
   Page := 1;
   GetDir(0,HomeDir);
   IF Copy(HomeDir,Length(HomeDir),1) <> '\' THEN
      HomeDir := HomeDir + '\';
   HomeDir := FExpand(HomeDir);
   CurrentFile := HomeDir + '???';
   CurrentTemplate := HomeDir + '*.*';
END.

