
{Unit IOLib contains basic Text mode IO procedures and some pre-defined
 colors}


UNIT IOLib;

INTERFACE

USES Crt,ScrLib;

TYPE

    CharSet = Set OF Char;

CONST

{colors}
        Video1     : Byte = 7;       {30}
        Video2     : Byte = 7;       {31}
        Video3     : Byte = 7;       {111}
        HiVid      : Byte = 15;      {28}
        RevVid     : Byte = 112;     {112}
        RevVid2    : Byte = 112;     {63}
        RevVid3    : Byte = 112;     {62}
        ErrorVid   : Byte = 112;     {79}
        UnderVid   : Byte = 1;       {28}
        BackTextVid : Byte = 7;      {16}

PROCEDURE HaltProgram;
PROCEDURE SlowWrite(x,y : Byte; St : String);
PROCEDURE CenterText(Y,Att : Byte; St : String);
PROCEDURE HighlightWrite(X,Y,N,Att,HiAtt : Byte;St : String);
PROCEDURE ClearLine(Y : Byte);
PROCEDURE ClearEOL(X,Y : Byte);
PROCEDURE GetKeys(VAR Ch,ExtCh : Char);
FUNCTION ReturnYesNo : Char;
FUNCTION ReturnLetter(Chrs : CharSet) : Char;
PROCEDURE SetColors;

IMPLEMENTATION

(****Error trapping procedures****)

PROCEDURE HaltProgram;
          BEGIN
               SetCursorSize(Cursor);
               NormVideo;
               ClrScr;
               Halt;
END;

(****I/O procedures, TextMode****)

PROCEDURE SlowWrite(x,y : Byte; St : String);
          BEGIN
               GoToXY(x,y);
               Write(St);
END;
PROCEDURE CenterText(Y,Att : Byte; St : String);
          VAR
             Posit : Word;
          BEGIN
               Posit := Pred(Y) * 160 + (80 - (Byte(St[0]) DIV 2) * 2);
               VarFWrite(Posit,Att,St);
END;
PROCEDURE HighlightWrite(X,Y,N,Att,HiAtt : Byte;St : String);
          VAR
             Posit : Word;
          BEGIN
               Posit := GetScrPos(X,Y);
               FastWrite(Posit,Att,St);
               Inc(Posit,Pred(N)*2);
               WriteChar(Posit,St[N],HiAtt);
END;
PROCEDURE ClearLine(Y : Byte);
          VAR
             Posit : Word;
          BEGIN
               Posit := Pred(Y) * 160;
               CharToScreen(Posit,80,' ',TextAttr);
END;
PROCEDURE ClearEOL(X,Y : Byte);
          BEGIN
               CharToScreen(GetScrPos(X,Y),81-X,' ',TextAttr);
END;
PROCEDURE GetKeys(VAR Ch,ExtCh : Char);
           BEGIN
                ExtCh := #0;
                Ch := ReadKey;
                IF Ch = #0 THEN
                   ExtCh := ReadKey;
END;
FUNCTION ReturnYesNo : Char;
         VAR
            Ch,Ch2 : Char;
         BEGIN
              REPEAT
                    GetKeys(Ch,Ch2);
                    Ch := UpCase(Ch);
              UNTIL Ch IN ['Y','N'];
              ReturnYesNo := Ch;
END;
FUNCTION ReturnLetter(Chrs : CharSet) : Char;
         VAR
            Ch,Ch2 : Char;
         BEGIN
              REPEAT
                    GetKeys(Ch,Ch2);
                    Ch := Upcase(Ch);
              UNTIL Ch IN Chrs;
              ReturnLetter := Ch;
END;
PROCEDURE SetColors;
          BEGIN
               IF Color THEN BEGIN
                  Video1     := 30;
                  Video2     := 31;
                  Video3     := 111;
                  HiVid      := 28;
                  RevVid     := 112;
                  RevVid2    := 63;
                  RevVid3    := 62;
                  ErrorVid   := 79;
                  UnderVid   := 28;
                  TextAttr   := Video2;
                  BackTextVid := 16;
               END;
END;
BEGIN
END.
