{$A+,B-,D+,E-,F-,I-,L+,N+,O-,R-,S-,V-}
{$M 64000,0,655360}
UNIT Jennrich;
INTERFACE

USES GlobType,HRange,Linlib,Graph,Crt;

PROCEDURE PlotAllJennrichT(n : Word;VAR X,Y  : Arr;Title : String);

IMPLEMENTATION

     CONST
          Color95    : Byte = White;
          Color90    : Byte = LightCyan;
          Color75    : Byte = LightGreen;
          PointColor : Byte = Yellow;

PROCEDURE PointXY(    MeanX,MeanY,Gamma,SinT,CosT,a,b : Single;
                  VAR PointX,PointY                   : Word);
           VAR
               ArcPosX,ArcPosY,HoldX : Single;
           BEGIN
                ArcPosX := Cos(Gamma) * A;
                ArcPosY := Sin(Gamma) * B;
                HoldX   := ArcPosX  * CosT -
                           ArcPosY * SinT;
                ArcPosY := ArcPosY * CosT +
                           ArcPosX * SinT;
                PointX := Round(HoldX + MeanX);
                PointY := Round(ArcPosY + MeanY);
END;
PROCEDURE ScaleSystem(    n                  : Word;
                      VAR X,Y                : Arr;
                      VAR MinX,MinY,Scale,
                          Diff               : Single;
                      VAR ScreenDim          : Word);
          VAR
             MaxX,MaxY,DiffY : Single;
          BEGIN
               MaxX := Max(n,X);
               MaxY := Max(n,Y);
               MinX := Min(n,X);
               MinY := Min(n,Y);
               Diff := MaxX - MinX;
               DiffY := MaxY - MinY;
               IF DiffY > Diff THEN
                  Diff := DiffY;
               ScreenDim := GetMaxY;
               Scale := (0.60 * ScreenDim);
               ScreenDim := ScreenDim SHR 2;
END;
PROCEDURE t(x,y : Word);
          BEGIN
               Line(x,y-2,x,y+2);
               Line(x+2,y,x-2,y);
END;
PROCEDURE PlotPts(    n                       : Word;
                  VAR X,Y                     : Arr;
                      Scale,MinX,MinY,Diff    : Single;
                      ScreenDim               : Word);
          VAR
             Ct,PtX,PtY : Word;
          BEGIN
               Scale := Scale/Diff;
               SetColor(PointColor);
               FOR Ct := 1 TO N DO BEGIN
                   PtX := Round((X[Ct] - MinX) * Scale) + ScreenDim;
                   PtY := GetMaxY-Round((Y[Ct] - MinY) * Scale) - ScreenDim;
                   T(PtX,PtY);
               END;
END;
PROCEDURE PlotJT(MeanX,MeanY,MinX,MinY,Scale,Diff,a,b,Theta   : Single;
                 ScreenDim                                    : Word);
          VAR
             Increment           : Single;
             Gamma,SinT,CosT     : Single;
             PosX,PosY           : Word;
             Ct                  : Word;
          BEGIN
               A := A/Diff * Scale;
               B := B/Diff * Scale;
               MeanX := (MeanX - MinX)/Diff;
               MeanY := (MeanY - MinY)/Diff;
               MeanX := MeanX * Scale + ScreenDim;
               MeanY := GetMaxY - (MeanY * Scale) - ScreenDim;
               Theta := -Theta;
               SinT := Sin(Theta);
               CosT := Cos(Theta);
               Increment := (2 * Pi)/50;
               Gamma := 0;
               PointXY(MeanX,MeanY,Gamma,SinT,CosT,a,b,PosX,PosY);
               MoveTo(PosX,PosY);
               FOR Ct := 1 TO 100 DO BEGIN
                   Gamma := Gamma + Increment;
                   PointXY(MeanX,MeanY,Gamma,SinT,CosT,a,b,PosX,PosY);
                   LineTo(PosX,PosY);
               END;
END;
PROCEDURE JTTitle(FileName : String);
          BEGIN
               Setcolor(LightRed);
               OutTextXY(GetMaxX-130,10,FileName);
               SetColor(White);
               OutTextXY(GetMaxX-170,20,'Contour %   Area (ha)');
               SetTextJustify(1,1);
               OutTextXY(GetMaxX SHR 1, GetMaxY - 10,'Any key to continue');
               SetTextJustify(0,2);
END;
PROCEDURE JTLegend(Y,Level : Word; Area,Corr : Single);
          VAR
             St     : String;
             St2    : String[10];
             StartX : Word;
          BEGIN
              StartX := GetMaxX - 140;
              SetLineStyle(0,0,3);
              CASE Level OF
                   3 : BEGIN
                            SetColor(Color95);
                            St := '95';
                       END;
                   2 : BEGIN
                            SetColor(Color90);
                            St := '90';
                       END;
                   1 : BEGIN
                            SetColor(Color75);
                            St := '75';
                       END;
              END;
              Line(StartX+10,Y+3,StartX - 10,Y+3);
              SetColor(White);
              Area := Area/InputScale;
              Str(Area:8:1,St2);
              St := St + St2;
              OutTextXY(StartX+20,Y,St);
END;
PROCEDURE SetColors;
          VAR
             Gd,Gm : Integer;
          BEGIN
               DetectGraph(Gd,Gm);
               IF Gd = 7 THEN BEGIN
                  Color95    := White;
                  Color90    := White;
                  Color75    := White;
                  PointColor := White;
               END;
END;
PROCEDURE PlotAllJennrichT(n : Word;VAR X,Y  : Arr;Title : String);
          VAR
             a,b,MinX,MinY,Scale,Theta,Diff      : Single;
             MeanX,MeanY,Area,CorrX              : Extended;
             ScreenDim                           : Word;
          BEGIN
               SetColors;
               JTTitle(Title);
               JennrichTGeneral(n,3,X,Y,Area,MeanX,MeanY,CorrX,a,b,Theta);
               ScaleSystem(n,X,Y,MinX,MinY,Scale,Diff,ScreenDim);
               PlotPts(n,X,Y,Scale,MinX,MinY,Diff,ScreenDim);
               JtLegend(30,3,Area,CorrX);
               SetColor(Color95);
               PlotJt(MeanX,MeanY,MinX,MinY,Scale,Diff,a,b,Theta,ScreenDim);
               JennrichTGeneral(n,2,X,Y,Area,MeanX,MeanY,CorrX,a,b,Theta);
               JtLegend(40,2,Area,CorrX);
               SetColor(Color90);
               PlotJt(MeanX,MeanY,MinX,MinY,Scale,Diff,a,b,Theta,ScreenDim);
               JennrichTGeneral(n,1,X,Y,Area,MeanX,MeanY,CorrX,a,b,Theta);
               JtLegend(50,1,Area,CorrX);
               SetColor(Color75);
               PlotJt(MeanX,MeanY,MinX,MinY,Scale,Diff,a,b,Theta,ScreenDim);
               SetLineStyle(0,0,0);
END;


BEGIN
END.



