{$A+,B-,D+,E-,F-,I-,L+,N+,O-,R-,S-,V-}
{$M 64000,0,655360}
UNIT JenStat;

INTERFACE

USES GlobType,HRange,Linlib;

{on return, JennrichContour replaces X,Y,n with the contour values}

PROCEDURE JennrichContour( VAR n                : Word;
                           VAR X,Y              : AkArr;
                               Level            : Word);

IMPLEMENTATION

PROCEDURE PointXY(    MeanX,MeanY,Gamma,SinT,CosT,a,b : Single;
                  VAR PointX,PointY                   : Single);
           VAR
               ArcPosX,ArcPosY,HoldX : Single;
           BEGIN
                ArcPosX := Cos(Gamma) * A;
                ArcPosY := Sin(Gamma) * B;
                HoldX   := ArcPosX  * CosT -
                           ArcPosY * SinT;
                ArcPosY := ArcPosY * CosT +
                           ArcPosX * SinT;
                PointX := HoldX + MeanX;
                PointY := ArcPosY + MeanY;
END;
PROCEDURE ProduceJT(    MeanX,MeanY,a,b,Theta              : Single;
                    VAR NewN                               : Word;
                    VAR XX,YY                              : AkArr);
          VAR
             Increment           : Single;
             Gamma,SinT,CosT     : Single;
             Ct                  : Word;
          BEGIN
               Increment := (2 * Pi)/50;
               Gamma := 0;
               NewN := 1;
               SinT := Sin(Theta);
               CosT := Cos(Theta);
               PointXY(MeanX,MeanY,Gamma,SinT,CosT,a,b,XX[NewN],
                       YY[NewN]);
               FOR Ct := 1 TO 100 DO BEGIN
                   Inc(NewN);
                   Gamma := Gamma + Increment;
                   PointXY(MeanX,MeanY,Gamma,SinT,CosT,a,b,XX[NewN],
                       YY[NewN]);
               END;
END;

PROCEDURE JennrichContour( VAR n                : Word;
                           VAR X,Y              : AkArr;
                               Level            : Word);
          VAR
             a,b,Theta                           : Single;
             MeanX,MeanY,Area,CorrX              : Extended;
             XX,YY                               : Arr;
          BEGIN
               Level := 4 - Level;
               MoveRow(X,XX,n);
               MoveRow(Y,YY,n);
               JennrichTGeneral(n,Level,XX,YY,Area,MeanX,MeanY,CorrX,a,b,Theta);
               ProduceJt(MeanX,MeanY,a,b,Theta,n,X,Y);
END;
BEGIN
END.



