UNIT Stat;

INTERFACE

USES GlobType,AkLib,ContLib,HRange,Linlib,Crt,MCP;

PROCEDURE Stats(    n           : Word;
                VAR X,Y         : Arr;
                VAR FileName,
                    StartDate,
                    StopDate    : String);

IMPLEMENTATION

PROCEDURE StartStop(VAR StartDate,StopDate : String);
          BEGIN
               GoToXY(30,2);
               Write('The Starting Date : ',StartDate);
               GoToXY(30,3);
               Write('The Ending   Date : ',StopDate);
               GoToXY(1,1);
END;
PROCEDURE DoContours(    n               : Word;
                     VAR X,Y             : AkArr;
                     VAR Grid            : AkMatrix);
          VAR
             Poly : PolyPtr;
             Ct   : Word;
          BEGIN
               New(Poly);
              InitContour(n,x,y,Grid);
               WriteLn;
               WriteLn('Adaptive Kernel');
               WriteLn('Contour      Area (ha)    #Polygons');
               WITH Poly^ DO BEGIN
                  FOR Ct := 1 TO Pred(ContNo) DO BEGIN
                      MakeAContour(n,ContVect[Ct],Poly^,Grid);
                      WriteLn(ContVect[Ct]:7:2,Area/InputScale:15:2,NPoly:9);
                  END;
                  Inc(Ct);
                  MakeAContour(n,ContVect[Ct],Poly^,Grid);
                  Write(ContVect[Ct]:7:2,Area/InputScale:15:2,NPoly:9);
               END;
               DisposeContour;
               Dispose(Poly);
END;
PROCEDURE DoJennrichT(n : Word;VAR x,y : Arr);
          BEGIN
               WriteLn;
               WriteLn('Jennrich Turner');
               WriteLn('Contour      Area (ha)');
               WriteLn('   0.95',JennrichT(n,3,x,y)/InputScale:15:2);
               WriteLn('   0.90',JennrichT(n,2,x,y)/InputScale:15:2);
               WriteLn('   0.75',JennrichT(n,1,x,y)/InputScale:15:2);
END;
PROCEDURE DoMCPStats(n : Word;VAR x,y : AKArr);
          VAR
             NewN : Word;
             Area : Single;
          BEGIN
               MakeMCP(n,x,y,NewN,Area);
               GotoXY(31,7);
               Write('Minimum Convex Polygon');
               GotoXY(31,8);
               Write('Contour      Area (ha)');
               GotoXY(31,9);
               Write('   1.00',Area/InputScale:15:2);
END;

PROCEDURE Stats(    n           : Word;
                VAR X,Y         : Arr;
                VAR FileName,
                    StartDate,
                    StopDate    : String);
          VAR
             XX,YY : AkArrPtr;
             Grid  : AkMatPtr;
          BEGIN
               New(Xx);
               New(Yy);
               New(Grid);
               MoveRow(x,Xx^,n);
               MoveRow(y,Yy^,n);
               StartStop(StartDate,StopDate);
               WriteLn('The File : ',FileName);
               WriteLn;
               WriteLn('Number of points : ',n:5);
               WriteLn('Schoener''s Ratio : ',Schoener(n,X,Y):5:2);
               DoJennrichT(n,x,y);
               DoAK(n,Xx^,Yy^,Grid^);
               Docontours(n,Xx^,Yy^,Grid^);
               DoMCPStats(n,Xx^,Yy^);
               Dispose(Grid);
               Dispose(Xx);
               Dispose(Yy);
END;

BEGIN
END.
