{$A+,B-,D+,E+,F-,I-,L+,N+,O-,R-,S-,V-}
{$M 64384,124000,655360}
USES WindLib,FileDisp,IOLib,ScrLib,Menu123,GetFile,Linlib,Graph3d,TreeGra,
     Crt,Graph,Dos,Utility,VGAPal,LaserPr,Globtype,Jennrich,AKLib,
     AKGraph,AkPlot,Stat,FileIn,PrintSc2,Drivers,Freq,FileOut,HRange;
CONST
     Shadow    : Boolean = TRUE;

MainMenu : Menu =
                  (FirstLine : ('File','Schoener','Input','3D hist.',
                                'Time path','Mode/mean','Range','Quit');
                  SecondLine : ('Input a UTM points file',
                                'Calculate Schoener index for chosen file',
                                'Set file input parameters',
                                '3D histogram to screen',
                                'Plot path over time',
                                'Toggle from mean to mode',
                                'Compute home range estimates',
                                'Exit the program');
                  FstCharSet   : 'FSI3TMRQ';
                  Locations    : (0,0,0,0,0,0,0,0);
                  EntryNo      : 8;
                  Position     : 1;     {initialize bar to start at position 1}
                  TopLineAtt   : 7;     {start with monochrome colors}
                  BotLineAtt   : 15;
                  FstCharAtt   : 15;
                  LightBar     : 112;
                  FirstBar     : 1);
MainMenuColors : ColorSet123 = (63,112,60,31,28);
TimeWindow     : LightBarWindow =
                            (WindArea    : NIL;
                             EntryNo     : 3;
                             TextArr     :
                                ('color by Bird',
                                 'color by Season',
                                 'breeding/Non-breeding','','');
                             LetterSt    : 'BSN';
                             Position    : (10,10,10,1,1);
                             BoxBorder   : BoxExt1;
                             BoxColor    : 112;
                             InnerColor  : 7;
                             HiColor     : 15;
                            BarColor    : 112;
                             HiBarColor  : 1;
                             LightBarPos : 1); {1 = first pos}
HomeRangeWindow     : LightBarWindow =
                            (WindArea    : NIL;
                             EntryNo     : 5;
                             TextArr     :
                                ('Jennrich/Turner',
                                 'Adaptive kernel',
                                 'MCP',
                                 'Statistics',
                                 'File output');
                             LetterSt    : 'JAMSF';
                             Position    : (1,1,1,1,1);
                             BoxBorder   : BoxExt1;
                             BoxColor    : 112;
                             InnerColor  : 7;
                             HiColor     : 15;
                             BarColor    : 112;
                             HiBarColor  : 1;
                             LightBarPos : 1); {1 = first pos}
AkWindow            : LightBarWindow =
                            (WindArea    : NIL;
                             EntryNo     : 2;
                             TextArr     :
                                ('Contours',
                                 '3d Plot',
                                 '','','');
                             LetterSt    : 'CP';
                             Position    : (1,4,1,1,1);
                             BoxBorder   : BoxExt1;
                             BoxColor    : 112;
                             InnerColor  : 7;
                             HiColor     : 15;
                             BarColor    : 112;
                             HiBarColor  : 1;
                             LightBarPos : 1); {1 = first pos}

ColorSet1 : ColorArr = (111,62,63,28,31);

VAR
   XArr,YArr  : Arr;
   DateArr    : String8Arr;
   PtNo       : Word;
   DistInc    : Single;
   MaxHistHt,
   BirdCtr        : Word;
   BirdName       : DataIndex;
   TimeSlice      : Byte;
   NewBird        : Boolean;
   LastJul        : LongInt;

(* ********************************************************** *)

VAR
   x,y                    : Arr;
   ModeSw                 : Boolean;
   Scaler                 : Single;
PROCEDURE GetKeys(VAR Ch,Ch2 : Char);
          VAR
             Err : Boolean;
          LABEL
               Loop;
          BEGIN
      LOOP:
               Ch2 := #0;
               Ch := UpCase(ReadKey);
               IF Ch = #0 THEN
                  Ch2 := ReadKey;
               WITH GlobIO DO BEGIN
                  IF GraphOn AND (Printer <> 0) THEN BEGIN
                     IF Ch2 = #25 THEN BEGIN
                        IF Printer = 1 THEN
                           PrintScreen(FALSE,Gd,Err)
                         ELSE
                             LaserPrintScreen(Gd,Err);
                     END
                     ELSE IF Ch2 = #17 THEN BEGIN
                          IF Printer = 1 THEN
                             PrintScreen(TRUE,Gd,Err)
                          ELSE
                              LaserLandscapePrintScreen(Gd,Err);
                     END
                     ELSE Exit;
                     GOTO Loop;
                  END;
               END;
END;

{JulDay Constructs the julian date from a year date}

FUNCTION Julday(Mm,Id,Iyyy: Integer): LongInt;
CONST
   Igreg=588829;
VAR
   Ja,Jm,Jy,Jul: LongInt;
BEGIN
   IF  (Iyyy = 0) THEN BEGIN
      Writeln('there is no year zero.'); Readln;
   END;
   IF  (Iyyy < 0) THEN  Iyyy := Iyyy+1;
   IF  (Mm > 2)  THEN BEGIN
      Jy := Iyyy;
      Jm := Mm+1
   END ELSE BEGIN
      Jy := Iyyy-1;
      Jm := Mm+13
   END;
   Jul := Trunc(365.25*Jy)+Trunc(30.6001*Jm)+Id+1720995;
   IF  (Id+31*(Mm+12*Iyyy) >= Igreg)  THEN BEGIN
      Ja := Trunc(0.01*Jy);
      Jul := Jul+2-Ja+Trunc(0.25*Ja)
   END;
   Julday := Jul
END;

{GetMode is one of the most god-awful pieces of junk that I have ever written,
 but it seems to work.  It integerizes a 2-d coordinate system and keeps track
 of the count in a separate array called Hist.  On output it places the mode
 at the point right in the middle of the integerized mode point}

PROCEDURE GetMode(    n                   : Word;
                  VAR X,Y                 : Arr;
                      Scaler              : Single;
                  VAR ModeX,ModeY         : Extended;
                  VAR ModeStrength        : Word);
          VAR
             ArrX,ArrY            : LongIntegerArr;
             Hist                 : IntegerArr;
             Scale                : Single;
             LongHolderX,
             LongHolderY          : LongInt;
             Ctr,Ct,Ct2,
             HistHolder           : Word;
             Found                : Boolean;
        LABEL
             JumpLoop;
          BEGIN
               FillChar(Hist,SizeOf(Hist),0);
               Scale := 1/Scaler;
               Ctr := 1;
               ArrX[1] := Round(X[1]*Scale);        {init list}
               ArrY[1] := Round(Y[1]*Scale);
               Hist[1] := 1;
               FOR Ct := 2 TO n DO BEGIN
                   LongHolderX := Trunc(X[Ct]*Scale);
                   LongHolderY := Trunc(Y[Ct]*Scale);
                   Found := FALSE;
                   FOR Ct2 := 1 TO Ctr DO BEGIN
                       IF ArrX[Ct2] = LongHolderX THEN BEGIN
                          IF LongHolderY = ArrY[Ct2] THEN BEGIN
                             Found := TRUE;
                             Inc(Hist[Ct2]);      {increase ct for that loc}
                             GOTO JumpLoop;   {all done, now get out}
                          END;
                       END;
                   END;
       JumpLoop:
                   IF NOT Found THEN BEGIN  {not in list? add it}
                      Inc(Ctr);
                      Inc(Hist[Ctr]);
                      ArrX[Ctr] := LongHolderX;
                      ArrY[Ctr] := LongHolderY;
                   END;
               END;
               ModeStrength := 0;
               HistHolder := 0;
               FOR Ct := 1 TO Ctr DO BEGIN               {search for mode}
                   IF Hist[Ct] > ModeStrength THEN BEGIN
                      ModeStrength := Hist[Ct];
                      HistHolder   := Ct;
                    END;
               END;
               ModeX := (ArrX[HistHolder] * Scaler) + (Scaler * 0.5);
               ModeY := (ArrY[HistHolder] * Scaler) + (Scaler * 0.5);
END;

{MeanOrMode toggles between using the mean or the mode as the center
 for calculating the Schoener ratio}

PROCEDURE  MeanOrMode(    n         : Word;    {needs ModeSw = Boolean = glob}
                      VAR X,Y       : Arr;     {scaler = single = glob}
                      VAR Mx,My     : Extended;
                          ErrorMsg  : Boolean);
               VAR
                  ModeNo : Word;
                  Ptr    : Pointer;
                  St     : String;
           BEGIN
                IF ModeSw THEN BEGIN
                   GetMode(n,X,Y,Scaler,Mx,My,ModeNo);
                   IF (ModeNo < Round(n/20)) AND ErrorMsg THEN BEGIN
                      Str(ModeNo,St);
                      St := 'Note : Mode poorly defined = '+ St;
                      OpenOneLineWindow(Ptr,20,18,ErrorVid,ErrorVid,
                                        BoxExt2,St,Shadow);
                      Delay(1000);
                      RestoreWindow(Ptr);
                   END;
                END
                ELSE BEGIN
                    Mx := Mean(n,X);
                    My := Mean(n,Y);
                END;
END;

{RandomTest randomizes the array and produces a Schoener ratio}

PROCEDURE RandomTest(N : Word;MeanX,MeanY : Extended;
                     x,y : Arr);   {perform random swapping}
          VAR
             Ct,Place        : Word;
          BEGIN
               Randomize;
               FOR Ct := 1 TO N DO BEGIN
                   Place := Random(N) + 1;
                   SwapElements(X[Ct],X[Place]);
                   SwapElements(Y[Ct],Y[Place]);
               END;
               WriteLn('Randomized Schoener ratio      : ',
                          Schoener2(n,MeanX,MeanY,X,Y):15:4);
END;

{SubSample produces uniform sub-samples and computes the Schoener ratio}

PROCEDURE SubSample(N,Modulus : Word;
                    x,y       : Arr;
                    ErrorMsg  : Boolean);   {sub-sample from set}
          VAR
             Ct,Place        : Word;
             MeanX,MeanY     : Extended;
          BEGIN
               IF N DIV Modulus < 10 THEN Exit;
               Place := 0;
               FOR Ct := 1 TO N DO BEGIN
                   IF Ct MOD Modulus = 0 THEN BEGIN
                      Inc(Place);
                      x[Place] := X[Ct];
                      y[Place] := Y[Ct];
                    END;
               END;
               MeanOrMode(Place,x,y,MeanX,MeanY,ErrorMsg);
               WriteLn('Sub-sample ',Place:3,' pts.         : ',
                         Schoener2(Place,MeanX,MeanY,X,Y):15:4);

END;

{sampleWOreplacement produces a sample N div Modulus large by producing random
 numbers from 1 to n until N div modulus unique numbers have been produced.
 the results of this process are held in a logical array [1..n] in which
 TRUE means that the number [i] has been produced at least once}

PROCEDURE SampleWOReplacement(    n,Modulus : Word;
                              VAR X,Y       : Arr;
                              VAR NewN      : Integer);
          VAR
             Ct,Ctr,
             RandHold      : Word;
             Indx          : BooleanArr;
          BEGIN
               NewN := N DIV Modulus;
               IF NewN < 10 THEN BEGIN     {if sample is too small indicate}
                  NewN := -1;              {this by producing an inproper}
                  Exit;                    {subset value}
               END;
               Randomize;
               FillChar(Indx,SizeOf(Indx),FALSE);  {set array to false}
               Ct := 0;
               WHILE Ct < NewN DO BEGIN            {fill it with NewN}
                     RandHold := Random(n) + 1;    {true entries}
                     IF NOT Indx[RandHold] THEN BEGIN
                        Indx[RandHold] := TRUE;
                        Inc(Ct);
                     END;
               END;
               Ctr := 0;
               FOR Ct := 1 TO N DO BEGIN          {collapse original}
                   IF Indx[Ct] THEN BEGIN         {point set to a set}
                      Inc(Ctr);                   {newN in length}
                      X[Ctr] := X[Ct];
                      Y[Ctr] := Y[Ct];
                   END;
               END;
END;

{RandomSubSample Produces a series of random sub-samples}

PROCEDURE RandomSubSample(N,Modulus : Word;
                          x,y       : Arr;       {random sub-sample from set}
                          ErrorMsg  : Boolean);          { w/o rep.}
          VAR
             NewN            : Integer;
             MeanX,MeanY     : Extended;
          BEGIN
               SampleWOReplacement(n,Modulus,x,y,NewN);
               IF NewN < 2 THEN Exit;
               MeanOrMode(NewN,x,y,MeanX,MeanY,ErrorMsg);
               WriteLn('Random sub-sample ',NewN:3,' pts.  : ',
                        Schoener2(NewN,MeanX,MeanY,X,Y):15:4);
END;


{Plot3d plots a 3d histogram on the screen}

PROCEDURE Plot3d(N,Mesh : Word;XPts,YPts : Arr;VAR FileName : String);
          TYPE
              IntegerVect             = Array[0..MaxPts] OF Word;
              IntVectPtr              = ^IntegerVect;
          VAR
             M                         : Matrix;
             Minn,MaxX,MaxY,Holder     : Single;
             IntVect,IntVect2          : IntVectPtr;
             X,Y                       : ArrPtr;
             Arr1,Arr2,Ct              : Integer;
             Ch,Ch2                    : Char;
       BEGIN
          New(IntVect);
          New(IntVect2);
          New(X);
          New(Y);
          Minn := Min(n,Xpts);
          AddConst(n,-Minn,Xpts);
          MaxX := Max(n,Xpts);
          Minn := Min(n,Ypts);
          AddConst(n,-Minn,Ypts);
          MaxY := Max(n,Ypts);
          IF MaxX < MaxY THEN     {scale to whichever axis is bigger}
             MaxX := MaxY;
          Init3DGraphics;
          REPEAT
             ClearDevice;
             SetTextJustify(0,2);
             X^ := XPts;
             Y^ := YPts;
             Holder := (1/MaxX) * (Mesh*1.0);
             MulConst(n,Holder,X^);         {grid}
             RoundAndScaleRow(n,1,X^,IntVect^);
             MulConst(n,Holder,Y^);
             RoundAndScaleRow(n,1,Y^,IntVect2^);
             ZeroFill(M,SizeOf(M));
             FOR Ct := 1 TO n DO BEGIN
                 Arr1 := Mesh -(IntVect2^[Ct]);
                 Arr2 := Mesh -(IntVect^[Ct]);
                 IF (Arr1 > 0) AND (Arr2 > 0) THEN
                    M[Arr2,Arr1] := M[Arr2,Arr1] + 1;
             END;
             Graph3DBarsG(Mesh+1,Mesh+1,M,0,1,0,1,FileName,'','',
                      'Esc to quit, PgUp, Pgdn to change grid',2,TRUE);
             DoFrequency(Mesh,Mesh,M);
             REPEAT
                 GetKeys(Ch,Ch2);
             UNTIL (Ch = #27) OR (Ch2 IN [#73,#81]);
             IF Ch2 = #81 THEN BEGIN
                IF Mesh > 5 THEN
                   Dec(Mesh,5);
             END;
             IF Ch2 = #73 THEN BEGIN
                IF Mesh < 45 THEN
                   Inc(Mesh,5);
             END;
          UNTIL Ch = #27;
          Dispose(IntVect);
          Dispose(IntVect2);
          Dispose(X);
          Dispose(Y);
          CloseGraphics;
END;

{GetNewColor is used to toggle new colors for multiple birds}

FUNCTION GetNewColor(Ct : Word):Byte;
         VAR
            NewColor : Byte;
         BEGIN
              Newcolor := ((Ct + 12) MOD 15)+ 1;
              GetNewColor := NewColor;
END;

{MakeBar Places a gray bar on the screen}

PROCEDURE MakeBar(X,Y : Word);
          BEGIN
               SetfillStyle(1,LightGray);
               Bar(X-5,Y-5,X+5,Y+5);
END;

{MakeBar2 now makes letters rather than bars Each letter represents a
telemetry pt.}

PROCEDURE MakeBar2(X,Y,n : Word);
          VAR
             St : String[3];
             Err : Integer;
             Mo : Byte;
             Color,NewColor : Byte;
          BEGIN
               Color := GetColor;
               IF NewBird THEN
                     Inc(BirdCtr);
               CASE TimeSlice OF
                    1 : SetColor(GetNewColor(BirdCtr));
                    2 : BEGIN
                             Val(Copy(DateArr[n],1,2),Mo,Err);
                             CASE Mo OF
                                  1..3   : SetColor(LightCyan);
                                  4..6   : SetColor(LightGreen);
                                  7..9   : SetColor(LightRed);
                                10..12   : SetColor(Yellow);
                              END;
                        END;
                    3 : BEGIN
                             Val(Copy(DateArr[n],1,2),Mo,Err);
                             CASE Mo OF
                                  1..2,9..12   : SetColor(Yellow);
                                  3..8         : SetColor(LightRed);
                              END;
                        END;
                END;
                SetTextJustify(1,1);
                OutTextXY(X,Y,Char(BirdCtr + 63));
                SetTextJustify(0,2);
                SetColor(Color);
END;

{WriteDate writes the data in the lower right corner of the screen}

PROCEDURE WriteDate(n : Word);
          VAR
             x,y : Word;
          BEGIN
               x := GetX;
               y := GetY;
               WriteChangingMsg(MaxX - 100,MaxY - 10,White,DateArr[n]);
               MoveTo(x,y);
END;

{MakeLine draws a line between 2 telemetry pts if it is appropriate}

PROCEDURE MakeLine(x,y,n : Word);
          VAR
             NewColor : Byte;
          BEGIN
               IF NewBird = FALSE THEN BEGIN
                  IF TimeSlice = 1 THEN
                      Newcolor := GetNewColor(BirdCtr)
                  ELSE
                      NewColor := White;
                  SetColor(NewColor);
                  LineTo(x,y);
               END
               ELSE
                   MoveTo(x,y);
END;

{IncIntRow Scales an integer array}

PROCEDURE IncIntRow(N : Word;AddConst : Word;VAR X : IntegerArr);
          VAR
             Ct : Word;
          BEGIN
               FOR Ct := 1 TO N DO
                   Inc(X[Ct],AddConst);
END;

{ConvertDateString converts a date string to 3 numbers}

FUNCTION ConvertDateSt(VAR St : String) : LongInt;
         VAR
            Mo,Da,Yr : Word;
            Err      : Integer;
         BEGIN
              Val(Copy(St,1,2),Mo,Err);
              Val(Copy(St,4,2),Da,Err);
              Val(Copy(St,7,2),Yr,Err);
              ConvertDateSt := JulDay(Mo,Da,Yr + 1900);
END;

{Delay is adjusted to reflect the time between subsequent sightings}

PROCEDURE ConvertDelay(n,DelNo : Word);
          VAR
             Diff          : Word;
             JDay          : LongInt;
          BEGIN
               JDay := ConvertDateSt(DateArr[n]);
               Diff := JDay - LastJul;
               IF Diff < 30 THEN
                  Delay(DelNo * Diff);
               LastJul := JDay;
END;

{Legend writes a legend on the screen}

PROCEDURE Legend;
          VAR
             Ct : Word;
             Ch : Char;
             x,y : Word;
          BEGIN
               Ct := 1;
               Ch := 'A';
               X := MaxX - 70;
               Y := 30;
               WHILE BirdName[Ct] <> 65535 DO BEGIN
                     IF TimeSlice = 1 THEN
                        SetColor(GetNewColor(Succ(Ct)))
                     ELSE
                         SetColor(White);
                     OutTextXY(X,Y,Ch + ' = '+ BirdNameSt[Ct]);
                     Inc(y,10);
                     Inc(Ct);
                     Inc(Ch);
               END;
               IF TimeSlice = 2 THEN BEGIN
                  MoveTo(10,10);
                  SetColor(LightGreen);
                  OutText('Spring ');
                  SetColor(LightRed);
                  OutText('Summer ');
                  SetColor(Yellow);
                  OutText('Fall ');
                  SetColor(LightCyan);
                  OutText('Winter ');
               END;
               IF TimeSlice = 3 THEN BEGIN
                  MoveTo(10,10);
                  SetColor(LightRed);
                  OutText('Breeding ');
                  SetColor(Yellow);
                  OutText('Non-Breeding ');
               END;
END;

{OneKilometer produces a 1 Km bar in the lower left corner of the screen}

PROCEDURE OneKilometer(MX : Single);
          VAR
             Dist : LongInt;
             TopPt : Word;
          BEGIN
               SetColor(White);
               Dist := Round((InputScale/MX) * MaxY * 0.9);
               IF Dist < MaxY THEN BEGIN
                  TopPt := MaxY - Dist;
                  Line(5,MaxY,5,TopPt);
                  Line(2,MaxY,8,MaxY);
                  Line(2,TopPt,8,TopPt);
                  OutTextXY(7,MaxY - (Dist SHR 1),'Km');
               END;
END;

{MakeTrack draws the time line on the screen}

PROCEDURE MakeTrack(N : Word;X,Y : Arr;St : String;DelNo : Word);
          VAR
              MX,MY,
              MnX,MnY     : Single;
              MeanX,MeanY : Extended;
              GraphMeanX,
              GraphMeanY : Word;
              IX,IY      : IntegerArr;
              Ct         : Word;
              Ch,Ch2     : Char;
              Color      : Byte;
          BEGIN
               BirdCtr := 2;
               NewBird := FALSE;
               MnX := Min(N,X);
               MnY := Min(N,Y);
               AddConst(N,-MnX,X);
               AddConst(N,-MnY,Y);
               MX := Max(N,X);
               MY := Max(N,Y);
               MeanOrMode(N,x,y,MeanX,MeanY,TRUE);
               IF MY > MX THEN
                  MX := MY;
               InitializeGraphics;
               IF (TimeSlice = 1) AND (Gd = 9) THEN BEGIN
                  SetBkColor(Black);
                  ChangePalette(MaxChoice);
               END
               ELSE
                   SetBkColor(Blue);
               GraphMeanX := Round(MeanX * ((1/MX) * MaxX * 0.7));
               GraphMeanY := Round(MeanY * ((1/MX) * MaxY * 0.9));
               GraphMeanX := GraphMeanX + Round(MaxX * 0.15);
               GraphMeanY := GraphMeanY + Round( MaxY * 0.05);
               RoundAndScaleRow(N,
                   (1/MX) * MaxX * 0.7,
                   X,IX);
               RoundAndScaleRow(N,
                   (1/MX) * MaxY * 0.9,
                   Y,IY);
               IncIntRow(N,Round(MaxX * 0.15),IX);
               IncIntRow(N,Round(MaxY * 0.05),IY);
               WriteChangingMsg(MaxX SHR 1 - 52,MaxY - 10,Yellow,
                      '<ESC> to quit');
               Legend;
               OneKilometer(Mx);
               MoveTo(IX[1],MaxY - IY[1]);
               MakeBar2(GetX,GetY,1);
               SetColor(White);
               GraphMeanY := MaxY - GraphMeanY;
               IF DelNo <> 0 THEN
                  LastJul := ConvertDateSt(DateArr[1]);
               FOR Ct := 2 TO n DO BEGIN
                   NewBird := (Ct = BirdName[BirdCtr]);
                   MakeLine(IX[Ct],MaxY - IY[Ct],Ct);
                   MakeBar(GraphMeanX,GraphMeanY);
                   MakeBar2(GetX,GetY,Ct);
                   IF TimeSlice <> 1 THEN
                      WriteDate(Ct);
                   IF KeyPressed THEN BEGIN
                      GetKeys(Ch,Ch2);
                      IF Ch = #27 THEN BEGIN
                         SetBkColor(Black);
                         CloseGraphics;
                         Exit;
                      END
                      ELSE
                          GetKeys(Ch,Ch2);
                   END;
                   IF (DelNo <> 0) AND NOT NewBird THEN
                      ConvertDelay(Ct,DelNo);
               END;
               SetColor(White);
               OutTextXY(MaxX - 100,10,St);
               WriteChangingMsg(MaxX SHR 1 - 76,MaxY - 10,LightRed,
                      'Any key to continue');
               GetKeys(Ch,Ch2);
               SetColor(White);
               SetBkColor(Black);
               IF (TimeSlice = 1) AND (Gd = 9) THEN BEGIN
                  ClearDevice;
                  ChangePalette(Normal);
               END;
               CloseGraphics;
END;

{DoSchoener calls all of the Schoener ratio procedures}

PROCEDURE DoSchoener(    n   : Word;
                     VAR X,Y : Arr);
          VAR
             MeanX,MeanY            : Extended;
             Ch,Ch2                 : Char;
             Ptr                    : Pointer;
          BEGIN
               TextAttr := RevVid;
               OpenTextWindow(Ptr,7,4,70,20,RevVid2,RevVid,BoxExt1,Shadow);
               GoToXY(1,1);
               WriteLn(n,' points');
               MeanOrMode(n,x,y,MeanX,MeanY,TRUE);
               WriteLn;
               IF ModeSw THEN BEGIN
                  WriteLn('The mode   : ',MeanX:15:4,MeanY:15:4);
                  WriteLn('The scalar : ',Scaler:15:4);
               END
               ELSE
                   WriteLn('The arithmetic mean  : ',
                            MeanX:15:4,MeanY:15:4);
               WriteLn;
               WriteLn('Schoener ratio                 : ',
                                 Schoener2(n,MeanX,MeanY,X,Y):15:4);
               RandomTest(N,MeanX,MeanY,x,y);
               WriteLn;
               SubSample(n,2,x,y,FALSE);
               SubSample(n,3,x,y,FALSE);
               SubSample(n,4,x,y,FALSE);
               RandomSubSample(n,2,x,y,FALSE);
               RandomSubSample(n,3,x,y,FALSE);
               RandomSubSample(n,4,x,y,FALSE);
               FastWrite(GetScrPos(30,20),ErrorVid,'Any key to continue');
               GetKeys(Ch,Ch2);
               TextAttr := Video1;
               Window(1,1,80,25);
               RestoreWindow(Ptr);
END;

{Do3d Calls the 3-d histogram routine}

PROCEDURE Do3D(N : Word;VAR X,Y : Arr;VAR FileName : String);
          VAR
             Ptr             : Pointer;
             Mesh            : Integer;
             ScreenArea      : Array[0..3999] OF Byte;
             EscSw           : Boolean;
          BEGIN
               TextAttr := RevVid;
               OpenTextWindow(Ptr,10,8,45,11,RevVid2,RevVid,BoxExt1,Shadow);
               GotoXY(1,1);
               Mesh := 5;
               Write('The Mesh size (5-50)  : ');
               SetCursorSize(Cursor);
               EscSw := InputInteger(28,1,2,5,50,Mesh);
               SetCursorSize(NoCursor);
               TextAttr := Video1;
               Window(1,1,80,25);
               IF EscSw THEN BEGIN
                 RestoreWindow(Ptr);
                 Exit;
               END
               ELSE BEGIN
                   BlockFromScreen(ScreenArea,0,2000);
                   Plot3d(n,Mesh,X,Y,FileName);
                   BlockToScreen(ScreenArea,0,2000);
                   RestoreWindow(Ptr);
               END;
END;


{TimeTrack calls MakeTrack which draws the time line on the screen}

PROCEDURE TimeTrack(N : Word;VAR X,Y : Arr;VAR FileName : String);
          VAR
             Ptr   : Pointer;
             DelNo : Integer;
             ScreenArea : Array[0..3999] OF Byte;
             EscSw : Boolean;
             Ch    : Char;
          BEGIN
               OpenLtBarWindow(30,4,TimeWindow,ColorSet1,Shadow);
               Ch := WindLightBar(TimeWindow);
               CASE Ch OF
                   'B' : TimeSlice := 1;
                   'S' : TimeSlice := 2;
                   'N' : TimeSlice := 3;
               END;
               RestoreWindow(TimeWindow.WindArea);
               IF Ch = #27 THEN Exit;
               TextAttr := RevVid;
               OpenTextWindow(Ptr,10,8,50,11,RevVid2,RevVid,BoxExt1,Shadow);
               GotoXY(1,1);
               DelNo := 50;
               Write('The Delay (milliseconds)  : ');
               SetCursorSize(Cursor);
               EscSw := InputInteger(1,29,4,0,1000,DelNo);
               SetCursorSize(NoCursor);
               TextAttr := Video1;
               Window(1,1,80,25);
               IF EscSw THEN BEGIN
                 RestoreWindow(Ptr);
                 Exit;
               END
               ELSE BEGIN
                   BlockFromScreen(ScreenArea,0,2000);
                   MakeTrack(n,X,Y,FileName,DelNo);
                   BlockToScreen(ScreenArea,0,2000);
                   RestoreWindow(Ptr);
               END;
END;

{HomeRange computes Jennrich-Turner and Adaptive Kernel estimates}

PROCEDURE HomeRange(N : Word;VAR X,Y : Arr;VAR FileName : String);
          VAR
             Grid       : AKMatPtr;
             XX,YY      : AKArrPtr;
             ScreenArea : Array[0..3999] OF Byte;
             Ch,Ch2     : Char;
             Ptr,Ptr2   : Pointer;
          BEGIN
               OpenLtBarWindow(50,3,HomeRangeWindow,ColorSet1,Shadow);
               Ch := WindLightBar(HomeRangeWindow);
               CASE Ch OF
                   #27 : RestoreWindow(HomeRangeWindow.WindArea);
                   'J' : BEGIN
                              RestoreWindow(HomeRangeWindow.WindArea);
                              BlockFromScreen(ScreenArea,0,2000);
                              InitializeGraphics;
                              PlotAllJennrichT(n,X,Y,FileName);
                              GetKeys(Ch,Ch2);
                              CloseGraphics;
                              BlockToScreen(ScreenArea,0,2000);
                         END;
                   'A' : BEGIN
                               Wait(Ptr);
                               New(Grid);
                               New(XX);
                               New(YY);
                               MoveRow(X,XX^,n);
                               MoveRow(Y,YY^,n);
                               DoAK(n,Xx^,Yy^,Grid^);
                               RestoreWindow(Ptr);
                               OpenLtBarWindow(43,4,AKWindow,
                              ColorSet1,Shadow);
                               Ch := WindLightBar(AKWindow);
                               RestoreWindow(AkWindow.WindArea);
                               RestoreWindow(HomeRangeWindow.WindArea);
                               IF Ch = #27 THEN BEGIN
                                  Dispose(Xx);
                                  Dispose(Yy);
                                  Dispose(Grid);
                                  Exit;
                               END;
                               BlockFromScreen(ScreenArea,0,2000);
                               CASE Ch OF
                                    'C' : BEGIN
                                               Makecontours(n,Grid^,Xx^,Yy^,
                                                  FileName,0,TRUE);
                                               GetKeys(Ch,Ch2);
                                               CloseGraphics;
                                           END;
                                    'P'  : BEGIN
                                                DrawGraph(Grid^,FileName);
                                           END;
                               END;
                               Dispose(XX);
                               Dispose(YY);
                               Dispose(Grid);
                               BlockToScreen(ScreenArea,0,2000);
                         END;
                   'M' : BEGIN
                              RestoreWindow(HomeRangewindow.WindArea);
                              BlockFromScreen(ScreenArea,0,2000);
                              DoMCP(n,x,y,FileName);
                              GetKeys(Ch,Ch2);
                              CloseGraphics;
                              BlockToScreen(ScreenArea,0,2000);
                         END;
                   'S' : BEGIN
                              RestoreWindow(HomeRangeWindow.WindArea);
                              Wait(Ptr2);
                              TextAttr := RevVid;
                              OpenTextWindow(Ptr,5,4,68,23,RevVid2,RevVid,BoxExt1,Shadow);
                              GotoXY(1,1);
                              Stats(n,X,Y,FileName,DateArr[1],DateArr[n]);
                              RestoreWindow(Ptr2);
                              FastWrite(GetScrPos(28,23),ErrorVid,'Any key to continue');
                              GetKeys(Ch,Ch2);
                              TextAttr := Video1;
                              Window(1,1,80,25);
                              RestoreWindow(Ptr);
                         END;
                   'F' : BEGIN
                              RestoreWindow(HomeRangeWindow.WindArea);
                              DoOutputMenu(n,X,Y);
                         END;
                END;

END;


{MeanModeWindow shows the user to whether the mean or the mode has been chosen}

PROCEDURE MeanModeWindow(VAR Ptr : Pointer);
          VAR
             St : String[11];
          BEGIN
               IF ModeSw THEN
                  St := 'Mode Chosen'
               ELSE
                   St := 'Mean Chosen';
               OpenOneLineWindow(Ptr,32,9,RevVid2,RevVid2,BoxExt2,St,Shadow);
END;


{DoMeanMode allows the user to toggle between the mean and the mode}

PROCEDURE DoMeanMode(n : Word;VAR X,Y : Arr;VAR Ptr : Pointer);
          VAR
             MaxX,MaxY,MinX,MinY : Single;
          BEGIN
               ModeSw := NOT ModeSw;
               RestoreWindow(Ptr);
               MeanModeWindow(Ptr);
               IF ModeSw THEN BEGIN   {compute scaler}
                  MaxX := Max(n,X);
                  MaxY := Max(n,Y);
                  MinX := Min(n,X);
                  MinY := Min(n,Y);
                  MaxX := MaxX - MinX;    {home range dimension}
                  MaxY := MaxY - MinY;
                  IF MaxY > MaxX THEN
                     MaxX := MaxY;
                  Scaler := MaxX/40;      {1/1600th of area}
               END;
END;


{The main calling procedure}


PROCEDURE DoMainMenu;
          VAR
             FileName,
             OldFile  : String;
             FileOk   : Boolean;
             Ptr      : Pointer;
             Ch       : Char;
             p        : PathStr;
             d        : NameStr;
             e        : ExtStr;
          BEGIN
               FileName := '???';
               FileOK := FALSE;
               SetColors;
               CharToScreen(0,2000,'',Video2);
               FastWrite(GetScrPos(51,23),Video2,
                          'USDA Forest Service ');
               FastWrite(GetScrPos(71,23),Video1,
                          'TELEM 1.0 ');
               WritePath;
               MeanModeWindow(Ptr);
               REPEAT
                  SetCursorSize(NoCursor);
                  Ch := DoMenu123(MainMenu,MainMenuColors);
                  CharToScreen(GetScrPos(51,23),30,'',Video2);
                  CASE Ch OF
                       'F' : BEGIN
                                 OldFile := FileName;
                                 SelectFile(FileName,FileOK,Shadow);
                                 IF FileOk THEN
                                    ReadPtsFile(FileName,XArr,YArr,DateArr,
                                                BirdName,PtNo,FileOk);
                                 IF FileOK THEN BEGIN
                                    FSplit(FileName,p,d,e);
                                    p := d + e;
                                 END
                                 ELSE
                                     ChangeFileName;
                                 WritePath;
                             END;
                       'S' : BEGIN
                                  IF FileOK THEN
                                     DoSchoener(PtNo,XArr,YArr)
                                  ELSE
                                      WindowErrors(5);
                             END;
                       'I' : BEGIN
                                  Input(GlobIO);
                                  FileOk := FALSE;
                             END;
                       '3' : BEGIN
                                IF FileOK THEN
                                     Do3d(PtNo,XArr,YArr,p)
                                  ELSE
                                      WindowErrors(5);
                             END;
                       'T' : BEGIN
                                  IF FileOK THEN
                                     TimeTrack(PtNo,XArr,YArr,p)
                                  ELSE
                                      WindowErrors(5);
                             END;
                       'M' : BEGIN
                                  IF FileOk THEN
                                     DoMeanMode(PtNo,XArr,YArr,Ptr)
                                  ELSE
                                      WindowErrors(5);
                             END;
                       'R' : BEGIN
                                  IF FileOk THEN
                                     HomeRange(PtNo,XArr,YArr,p)
                                  ELSE
                                      WindowErrors(5);
                             END;
                  END;
            UNTIL Ch IN [#27,'Q'];
            RestoreWindow(Ptr);
END;

(**************The main program**************)

BEGIN
     ModeSw := FALSE;
     Scaler := 20;
     DoMainMenu;
     SetcursorSize(Cursor);
     NormVideo;
     ClrScr;
END.
