UNIT TreeGra;

INTERFACE

USES Graph;

VAR
   MaxX,MaxY   : Word;
   AspRatio    : Single;
CONST
   GraphOn     : Boolean = FALSE;
   Gd          : Integer = 0;
   Gm          : Integer = 0;

PROCEDURE DrawAxes(Xorig,Yorig,Xlen,Ylen : Word;
                   VAR Xscale,Yscale : Single);
PROCEDURE DrawArrows(X,Y : Word);
PROCEDURE WriteSingle(X,Y : Word;Num : Single);
PROCEDURE WriteTitle(X,Y : Word;Title,Msg : String);
PROCEDURE WriteChangingMsg(X,Y : Word;Color : Byte;Msg : String);
PROCEDURE InitializeGraphics;
PROCEDURE CloseGraphics;

IMPLEMENTATION

{used in beta and triangle to draw the trunk}

PROCEDURE DrawAxes(Xorig,Yorig,Xlen,Ylen : Word;
                   VAR Xscale,Yscale : Single);
  BEGIN
    SetLineStyle(0,0,3);
    Setcolor(Brown);
    Xscale := Xlen/100.0;
    Yscale := Ylen/100.0;
    Line(Xorig,Yorig,Xorig,Yorig-Ylen);
    SetLineStyle(0,0,0);
END;

{Draws arrows at location X,Y}

PROCEDURE DrawArrows(X,Y : Word);
          VAR
             XP10,YP10,XM10,YM10 : Word;
          BEGIN
               SetColor(Yellow);
               OutTextXY(X-64,Y+20,'to alter profile');
               SetColor(White);
               XP10 := X + 10;
               XM10 := X - 10;
               YP10 := Y + 10;
               YM10 := Y - 10;
               Line(XP10,Y,XM10,Y);
               Line(X,YP10,X,YM10);
               Line(XP10,Y,X+7,Y-3);
               Line(XM10,Y,X-7,Y-3);
               Line(XP10,Y,X+7,Y+3);
               Line(XM10,Y,X-7,Y+3);
               Line(X,YP10,X+3,Y+7);
               Line(X,YM10,X-3,Y-7);
               Line(X,YP10,X-3,Y+7);
               Line(X,YM10,X+3,Y-7);
END;

{writes a formatted number at positon x,y}

PROCEDURE WriteSingle(X,Y : Word;Num : Single);
          VAR
             St        : String[6];
          BEGIN
               IF Num = 0.0 THEN
                  St := '  --- '
               ELSE
                  Str(Num:6:2,St);
               OutTextXY(X,Y,St);
END;
PROCEDURE WriteTitle(X,Y : Word;Title,Msg : String);
          BEGIN
               SetColor(Yellow);
               OutTextXY(X,Y,Title);
               SetColor(LightRed);
               SetTextJustify(1,1);
               OutTextXY(MaxX SHR 1,MaxY - 8,Msg);
               SetColor(White);
               SetTextJustify(2,0);
END;
{toggles the system into graphics mode}
PROCEDURE WriteChangingMsg(X,Y : Word;Color : Byte;Msg : String);
          VAR
             BarLen : Word;
          BEGIN
               BarLen := Word(Msg[0]) SHL 3; {*8}
               SetfillStyle(1,GetBkColor);
               SetColor(Color);
               Bar(X,Y + 4,X + BarLen,Y-4);
               SetTextJustify(0,1);
               OutTextXY(X,Y,Msg);
               SetTextJustify(0,2);
               SetColor(White);
END;
PROCEDURE InitializeGraphics;
          VAR
             AspX,AspY : Word;
          BEGIN
               IF Gd = 0 THEN BEGIN
                  InitGraph(Gd,Gm,'');
                  IF GraphResult <> 0 THEN BEGIN
                     WriteLn('BGI driver not found');
                     Halt;
                  END;
                  MaxX := GetMaxX;
                  MaxY := GetMaxY;    {set up some globals}
                  GetAspectRatio(AspX,AspY);
                  AspRatio := AspX/AspY;
               END
               ELSE
                   SetGraphMode(Gm);
               GraphOn := TRUE;
END;

{toggles the system into text mode}

PROCEDURE CloseGraphics;
          BEGIN
               ClearDevice;
               RestoreCrtMode;
               GraphOn := FALSE;
END;

BEGIN
END.
